/*  Chess-Ec      Copyright (C)   2001-2008 Marc Dechico

    ec_global.h : a common header file where global datas and functions
		are defined. 
		(working to change most of  them to static )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 37 98 22 54
				Mail: ec@chess-ec.org  
    
*/

#ifndef TYPES_H_   
#define TYPES_H
/* bug verify that define TYPES_H si correct */

/* AIX requires this to be the first thing in the file.  */
#if defined (_AIX) && !defined (__GNUC__)
 #pragma alloca
#endif
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <getopt.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <errno.h>


#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_LOCALE_H
#include <locale.h>
#endif

#if ENABLE_NLS
#include <libintl.h>
#define _(String) gettext (String)
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)

#else
#define _(String) (String)
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)

#endif
#ifndef errno
extern int errno;
#endif

#ifdef	STDC_HEADERS
#include <stdlib.h>
#else	/* Not STDC_HEADERS */
extern void exit ();
extern char *malloc ();
#endif	/* STDC_HEADERS */

#ifdef	HAVE_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif

#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#ifdef HAVE_SYS_FILE_H
#include <sys/file.h>
#endif

#ifdef	__GNUC__
#undef	alloca
#define	alloca(n)	__builtin_alloca (n)
#else	/* Not GCC.  */
#ifdef	HAVE_ALLOCA_H
#include <alloca.h>
#else	/* Not HAVE_ALLOCA_H.  */
#ifndef	_AIX
extern char *alloca ();
#endif	/* Not _AIX.  */
#endif	/* HAVE_ALLOCA_H.  */
#endif	/* GCC.  */

#ifdef HAVE_SYS_PARAM_H
/* To possibly get the definition of DEV_BSIZE. */
#include <sys/param.h>
#endif
#include "system.h"

#include	<ctype.h>
#include 	<signal.h>
#include        <sys/time.h>

/******************************************************************/
/* for including some  features                                   */
/******************************************************************/

//#define STHASH    /* one level implementation of hash           */
                    /* not compatible with UPLOAD_BRANCH          */

#define STHASH1     /* multi level implementation of hash         */
                    /* not compatible with UPLOAD_BRANCH          */

//#define UPLOAD_BRANCHE  /* upload the liste of move leadind to  */
                          /* use to build the best move           */ 
                        /* not compatible with STHASH AND STHASH1 */

/* LEA_PER_DEC not use any more  because I'll try another trick : */
/* comparison of not + typ_mvt_lea                                */
//#define  DEC_NOT_MAX_LEA  /* decrement the note when a taken    */
                          /* occures at leaf                      */

//#define  INC_POS_NOT      /* increment the note depending on the*/
                          /* the position of the piece on board   */
                          /* during the simulation                */
/* organization   should perhaps use a dynamic module */

#define TEST           /*include code or module to test the pgm */

/******************************************************************/
#if BORLAND_C == 1
#include 	<sys/timeb.h>
#if DOS == 1
#include <bios.h>
#endif
#else
#include 	<sys/time.h>
#endif

#include 	<time.h>
 
/* #define BORLAND_C   0 */			/* 0 = Non 1 = OUI */
/*#define GCC	    1 */
 

#if BORLAND_C == 1
#if DOS == 1
#define ESC 27
#endif
#endif

#if LINUX  == 1
const struct sigaction st_sig_act;	/* gestion message system */ 
#endif


/* directive conditionelle por debug */
#define CPT_ITE 0		/* 1 pour inclusion du code 0 sinon */
#define CTL_DEP_ECH_PIE 0	/*  pour controle dephasage entre echiquier et piece */ 



/* Longueur message utilisateur */
#define LEN_MES 200

/* Nombre de parametre a inclure dans messages */
#define NBR_MAX_PAR_MES 10
/* Longueur maximum du parametre */
#define LON_MAX_PAR_MES 80

/* Profondeur de hst_pro */
#define PRO_HST			300
/* Nombre maximum de mouvement initiaux */
#define MVT_INI			70

/* Profondeur maximum de simulation inferieur/superieur */
#define PRO_SIM_SUP_MAX 10
#define PRO_SIM_INF_MAX 20

/* number maximum of hash table to use*/  
#define NBR_MAX_HASH 10
/* Yes No  */
enum defv_bool 
{
	N=0,	
	Y=1
};
typedef enum defv_bool defv_bool;

/* type de rock */
#define PET_ROC			0
#define GRA_ROC 		1

/* Piece side  */
enum e_side 
{
	BLANC=0,	
	NOIR=1
};
typedef enum e_side  e_side;

/* Valeur possible pour  le camp */
/*
#define BLANC			0
#define NOIR    		1*/
#define VIDE                   -1
#define HOR_ECH                -2

/* Type de mouvements */
#define PAS_DE_MVT		0
/* cavalier tour fou reine  */
#define TFR_DEP			1
#define TFR_PRI			2
/* roi */
#define ROI_DEP			3
#define ROI_PRI		        4
#define ROI_GRA_ROC		5
#define ROI_PET_ROC		6
/* cavalier */
#define CAV_DEP			7
#define CAV_PRI			8
/* pion */
#define PIO_1C        		9
#define PIO_2C 	       		10
#define PIO_PRI			11
#define PIO_PRI_PAS		12

#define PIO_PRO_REI	        13
#define PIO_PRO_FOU	        14
#define PIO_PRO_TOU	        15
#define PIO_PRO_CAV	        16

#define PIO_PRO_REI_PRI	        17
#define PIO_PRO_FOU_PRI	        18
#define PIO_PRO_TOU_PRI	        19
#define PIO_PRO_CAV_PRI	        20

#define NBR_TYP_MVT             21

/* */
#define NOT_MIN        -32768    /* le plus grand nombre negatif pour le type int */
#define NOT_ROC_TOU      -10    /* empecher le roc  */

#define FOR_PIO           100
#define FOR_CAV           300
#define FOR_FOU           300
#define FOR_TOU           500
#define FOR_REI           900
 /* pour analyse couverture */
#define FOR_ROI             1

#define NOT_MAT           9000
 /* rapport de force limite au dessu duquel on arrete la descente (cut)*/  
#define RAP_FOR_LIM_CUT   700
/* increment or devrement the note when taking occure without gain */    
#define  INC_PRI_NUL       70     
/* perte limite au dessus delaquelle il faut essayer de negocier un pat */
#define  LIMIT_PAT       2000     
/* choice made with random when possible */
#define  RANDOM_CHOICE      1
/* how many among the best move are chose for random choise?  */
#define RANDOM_CHOICE_MAX  6

/* NOT_MAT_MIN est un seuil:
	au dessus on est certain que la note represente un mat et ce malgre le decrement de 10
	par profondeur (900 - 10 * 40 mvt successif )=500. La machine capable d'analyser sur une 
	prfondeur de 40 mvt n'existe pas encore.

	au dessous la note represente seulement des prises de piece car si toutes les piece etaient prises
	la note ne depasserai pas 400.

	La not d'une branche comportant un mat n'inclura plus les eventuelle prises de cette branche pour 
	pouvoir aller le plus rapidement au mat s'il est inevitable.
	
	On pourra savoir en combien de mvt successifs le mat inevitable pourra avoir lieu avec:
	Nbr mvt = (NOT_MAT - note)/10.
	cad si note = 880 mat inevitable en 2 coups.  
 
*/
#define NOT_MAT_MIN      5000   
/* at each depth the not mat is decremented by that value
   to ensure going as fast as possible to checkmat */
#define DEC_MAT           100
/* at leaf only a percentage of the note is taken because of the risk
   that another piece is taken  at next level without knowing */
#define LEA_PER_DEC       0.7


/* libelle colone <-> N de colonne */
#define A              1
#define B              2
#define C              3
#define D              4
#define E              5
#define F              6
#define G              7
#define H              8

/* libelle case <-> numero de case  */
#define A1              11
#define A2              21 
#define A3              31
#define A4              41
#define A5              51
#define A6              61
#define A7              71
#define A8              81

#define B1              12
#define B2              22
#define B3              32
#define B4              42
#define B5              52
#define B6              62
#define B7              72
#define B8              82

#define C1              13
#define C2              23
#define C3              33
#define C4              43
#define C5              53
#define C6              63
#define C7              73
#define C8              83

#define D1              14
#define D2              24
#define D3              34
#define D4              44
#define D5              54
#define D6              64
#define D7              74
#define D8              84

#define E1              15
#define E2              25
#define E3              35
#define E4              45
#define E5              55
#define E6              65
#define E7              75
#define E8              85

#define F1              16
#define F2              26
#define F3              36
#define F4              46
#define F5              56
#define F6              66
#define F7              76
#define F8              86

#define G1              17
#define G2              27
#define G3              37
#define G4              47
#define G5              57
#define G6              67
#define G7              77
#define G8              87

#define H1              18
#define H2              28
#define H3              38
#define H4              48
#define H5              58
#define H6              68
#define H7              78
#define H8              88

/* Modification de coordonnee roi, reine, fou, tour */
#define HH             +=10              /* haut        1 case */
#define HD             +=11              /* haut droite 1 case */
#define DD             +=1               /* droite      1 case */
#define BD             -=9               /* bas droite  1 case */
#define BB             -=10              /* bas         1 case */
#define BG             -=11              /* bas gauche  1 case */
#define GG             -=1               /* gauche      1 case */
#define HG             +=9               /* haut gauche 1 case */

#define _HH             +=10              /* haut        1 case */
#define _HD             +=11              /* haut droite 1 case */
#define _DD             +=1               /* droite      1 case */
#define _BD             -=9               /* bas droite  1 case */
#define _BB             -=10              /* bas         1 case */
#define _BG             -=11              /* bas gauche  1 case */
#define _GG             -=1               /* gauche      1 case */
#define _HG             +=9               /* haut gauche 1 case */


/* Modification de coordonnee cavalier */
#define CHD             +=21              /* cavalier haut droite */
#define CDH             +=12              /* cavalier droite haut */
#define CDB             -=8               /* cavalier droite bas  */
#define CBD             -=19              /* cavalier bas droite  */
#define CBG             -=21              /* cavalier bas gauche  */
#define CGB             -=12              /* cavalier gauche bas  */
#define CGH             +=8               /* cavalier gauche haut */
#define CHG             +=19              /* cavalier haut gauche */

/* Modification de coordonnee pion blanc */
#define PH1            +=10              /* pion haut 1        */
#define PH2            +=20              /* pion haut 2        */
#define PHG            +=9               /* pion haut gauche   */
#define PHD            +=11              /* pion haut droite   */

#define PB1            -=10              /* pion bas 1         */
#define PB2            -=20              /* pion bas 2         */
#define PBG            -=11              /* pion bas gauche    */
#define PBD            -=9               /* pion bas droite    */


/* Message d'erreur */
enum e_msg_nbr 
{
      MSG_CHA_MES_LON_MSG		,
      MSG_CHO_COT_INV			,
      MSG_CHO_INC_INV			,
      MSG_CHO_NIV_INC_INV		,
      MSG_CHO_NIV_INV			,
      MSG_EXI_MVT_INI_NON		,
      MSG_JOU_CTFR_ROI_ECH		,
      MSG_JOU_GRD_ROC_ROC_IMP		,
      MSG_JOU_INT_COL_ARR_INV		,
      MSG_JOU_INT_COL_DEP_INV		,
      MSG_JOU_INT_LIG_ARR_INV		,
      MSG_JOU_INT_LIG_DEP_INV		,
      MSG_JOU_PAS_DE_PIE		,
      MSG_JOU_PAS_VOT_TOU		,
      MSG_JOU_PET_ROC_ROC_IMP		,
      MSG_JOU_PIB_2CA_IMP		,
      MSG_JOU_PIB_ARR_OCC		,
      MSG_JOU_PIB_INT_OCC		,
      MSG_JOU_PIB_MVT_IMP		,
      MSG_JOU_PIB_PAS_PIE_PRI		,
      MSG_JOU_PIN_2CA_IMP		,
      MSG_JOU_PIN_MVT_IMP		,
      MSG_JOU_PIO_PIE_PRO_INV		,
      MSG_JOU_PIO_ROI_ECH		,
      MSG_JOU_POS_REP_P3F		,
      MSG_JOU_PRI_PRO_CAM		,
      MSG_JOU_ROI_GRD_ROC_IMP		,
      MSG_JOU_ROI_PET_ROC_IMP		,
      MSG_JOU_ROI_ROI_ECH		,
      MSG_MVT_CAV_MVT_IMP		,
      MSG_MVT_FOU_MVT_IMP		,
      MSG_MVT_FOU_SAU_PIE		,
      MSG_MVT_REI_MVT_IMP		,
      MSG_MVT_REI_SAU_PIE		,
      MSG_MVT_ROI_MVT_IMP		,
      MSG_MVT_TOU_MVT_IMP		,
      MSG_MVT_TOU_SAU_PIE		,
      MSG_PAS_COU_PRE			,
      MSG_RST_DSK_ERR_DON		,
      MSG_RST_DSK_ERR_FIC		,
      MSG_SAV_DSK_ERR_FIC		,
      MSG_SIMU_HST_SIZ			,
      MSG_SIMU_MAT_BLANC		,
      MSG_SIMU_MAT_NOIR			,
      MSG_SIMU_PAT_BLANC		,
      MSG_SIMU_PAT_NOIR			,
      MSG_TYP_LIB_CAV			,
      MSG_TYP_LIB_REI			,
      MSG_VER_AFF_NOT_IMP		,
      MSG_VER_CHO_PRO_PIO		,
      MSG_LIB_BLANC                     ,
      MSG_LIB_NOIR                      ,
      MSG_NBR  	                        
};

#define TRUE  1
#define FALSE 0

#define INI_MVT_INI_YES 1
#define INI_MVT_INI_NO  0

#define INI_RAP_FOR_YES 1
#define INI_RAP_FOR_NO  0

#define USE_HASH_YES 1
#define USE_HASH_NO  0


/************************************************************/
/* variable test */
# if CPT_ITE == 1
unsigned long int cpt;
# endif
/* tableau correspondance posx <-> libelle colonne */
static const char tc_lib_cas[100] [3]=
{
  /* 0 */ "  ",
  /* 1 */"  ",
  /* 2 */ "  ",
  /* 3 */ "  ",
  /* 4 */ "  ",
  /* 5 */ "  ",
  /* 6 */ "  ",
  /* 7 */ "  ",
  /* 8 */ "  ",
  /* 9 */ "  ",

  /* 10 */ "  ",
  /* 11 */ "A1",
  /* 12 */ "B1",
  /* 13 */ "C1",
  /* 14 */ "D1",
  /* 15 */ "E1",
  /* 16 */ "F1",
  /* 17 */ "G1",
  /* 18 */ "H1",
  /* 19 */ "  ",

  /* 20 */ "  ",
  /* 21 */ "A2",
  /* 22 */ "B2",
  /* 23 */ "C2",
  /* 24 */ "D2",
  /* 25 */ "E2",
  /* 26 */ "F2",
  /* 27 */ "G2",
  /* 28 */ "H2",
  /* 29 */ "  ",

  /* 30 */ "  ",
  /* 31 */ "A3",
  /* 32 */ "B3",
  /* 33 */ "C3",
  /* 34 */ "D3",
  /* 35 */ "E3",
  /* 36 */ "F3",
  /* 37 */ "G3",
  /* 38 */ "H3",
  /* 39 */ "  ",

  /* 40 */ "  ",
  /* 41 */ "A4",
  /* 42 */ "B4",
  /* 43 */ "C4",
  /* 44 */ "D4",
  /* 45 */ "E4",
  /* 46 */ "F4",
  /* 47 */ "G4",
  /* 48 */ "H4",
  /* 49 */ "  ",

  /* 50 */ "  ",
  /* 51 */ "A5",
  /* 52 */ "B5",
  /* 53 */ "C5",
  /* 54 */ "D5",
  /* 55 */ "E5",
  /* 56 */ "F5",
  /* 57 */ "G5",
  /* 58 */ "H5",
  /* 59 */ "  ",
	
  /* 60 */ "  ",
  /* 61 */ "A6",
  /* 62 */ "B6",
  /* 63 */ "C6",
  /* 64 */ "D6",
  /* 65 */ "E6",
  /* 66 */ "F6",
  /* 67 */ "G6",
  /* 68 */ "H6",
  /* 69 */ "  ",

  /* 70 */ "  ",
  /* 71 */ "A7",
  /* 72 */ "B7",
  /* 73 */ "C7",
  /* 74 */ "D7",
  /* 75 */ "E7",
  /* 76 */ "F7",
  /* 77 */ "G7",
  /* 78 */ "H7",
  /* 79 */ "  ",

  /* 80 */ "  ",
  /* 81 */ "A8",
  /* 82 */ "B8",
  /* 83 */ "C8",
  /* 84 */ "D8",
  /* 85 */ "E8",
  /* 86 */ "F8",
  /* 87 */ "G8",
  /* 88 */ "H8",
  /* 89 */ "  ",

  /* 90 */ "  ",
  /* 91 */ "  ",
  /* 92 */ "  ",
  /* 93 */ "  ",
  /* 94 */ "  ",
  /* 95 */ "  ",
  /* 96 */ "  ",
  /* 97 */ "  ",
  /* 98 */ "  ",
  /* 99 */ "  "	
};
/**********************************************************************************/
/* first version */
/* note for piece position */
typedef const char def_inc_not;

/* mark increment use for all piece that are not pawn*/

static def_inc_not  def_tc_inc_not_pawn[]=
{  
  /* 0     */ 0,
  /* 1     */ 0,
  /* 2     */ 0,
  /* 3     */ 0,
  /* 4     */ 0,
  /* 5     */ 0,
  /* 6     */ 0,
  /* 7     */ 0,
  /* 8     */ 0,
  /* 9     */ 0,

  /* 10    */ 0,
  /* 11 A1 */ 0,
  /* 12 B1 */ 1,
  /* 13 C1 */ 1,
  /* 14 D1 */ 1,
  /* 15 E1 */ 1,
  /* 16 F1 */ 1,
  /* 17 G1 */ 1,
  /* 18 H1 */ 0,
  /* 19    */ 0,

  /* 20    */ 0,
  /* 21 A2 */ 1,
  /* 22 B2 */ 2,
  /* 23 C2 */ 2,
  /* 24 D2 */ 2,
  /* 25 E2 */ 2,
  /* 26 F2 */ 2,
  /* 27 F2 */ 2,
  /* 28 H2 */ 2,
  /* 29    */ 1 ,

  /* 30    */ 0,
  /* 31 A3 */ 1,
  /* 32 B3 */ 2,
  /* 33 C3 */ 3,
  /* 34 D3 */ 3,
  /* 35 E3 */ 3,
  /* 36 F3 */ 3,
  /* 37 G3 */ 2,
  /* 38 H3 */ 1,
  /* 39    */ 0,

  /* 40    */ 0,
  /* 41 A4 */ 1,
  /* 42 B4 */ 2,
  /* 43 C4 */ 3,
  /* 44 D4 */ 4,
  /* 45 E4 */ 4,
  /* 46 F4 */ 3,
  /* 47 G4 */ 2,
  /* 48 H4 */ 1,
  /* 49    */ 0,

  /* 50    */ 0,
  /* 51 A5 */ 1,
  /* 52 B5 */ 2,
  /* 53 C5 */ 3,
  /* 54 D5 */ 4,
  /* 55 E5 */ 4,
  /* 56 F5 */ 3,
  /* 57 G5 */ 2,
  /* 58 H5 */ 1,
  /* 59    */ 0,
	
  /* 60    */ 0,
  /* 61 A6 */ 1,
  /* 62 B6 */ 2,
  /* 63 C6 */ 3,
  /* 64 D6 */ 3,
  /* 65 E6 */ 3,
  /* 66 F6 */ 3,
  /* 67 G6 */ 2,
  /* 68 H6 */ 1,
  /* 69    */ 0,

  /* 70    */ 0,
  /* 71 A7 */ 1,
  /* 72 B7 */ 2,
  /* 73 C7 */ 2,
  /* 74 D7 */ 2,
  /* 75 E7 */ 2,
  /* 76 F7 */ 2,
  /* 77 G7 */ 2,
  /* 78 H7 */ 1,
  /* 79    */ 0,

  /* 80    */ 0,
  /* 81 A8 */ 0,
  /* 82 B8 */ 1,
  /* 83 C8 */ 1,
  /* 84 D8 */ 1,
  /* 85 E8 */ 1,
  /* 86 F8 */ 1,
  /* 87 G8 */ 1,
  /* 88 H8 */ 0,
  /* 89    */ 0,

  /* 90    */ 0,
  /* 91    */ 0,
  /* 92    */ 0,
  /* 93    */ 0,
  /* 94    */ 0,
  /* 95    */ 0,
  /* 96    */ 0,
  /* 97    */ 0,
  /* 98    */ 0,
  /* 99    */ 0	

};

/* mark increment use for all piece that  pawn*/
static def_inc_not  def_tc_inc_pawn[]=
{  
  /* 0     */ 0,
  /* 1     */ 0,
  /* 2     */ 0,
  /* 3     */ 0,
  /* 4     */ 0,
  /* 5     */ 0,
  /* 6     */ 0,
  /* 7     */ 0,
  /* 8     */ 0,
  /* 9     */ 0,

  /* 10    */ 0,
  /* 11 A1 */ 0,
  /* 12 B1 */ 0,
  /* 13 C1 */ 0,
  /* 14 D1 */ 0,
  /* 15 E1 */ 0,
  /* 16 F1 */ 0,
  /* 17 G1 */ 0,
  /* 18 H1 */ 0,
  /* 19    */ 0,

  /* 20    */ 0,
  /* 21 A2 */ 0,
  /* 22 B2 */ 0,
  /* 23 C2 */ 0,
  /* 24 D2 */ 0,
  /* 25 E2 */ 0,
  /* 26 F2 */ 0,
  /* 27 F2 */ 0,
  /* 28 H2 */ 0,
  /* 29    */ 0,

  /* 30    */ 0,
  /* 31 A3 */ 1,
  /* 32 B3 */ 2,
  /* 33 C3 */ 3,
  /* 34 D3 */ 4,
  /* 35 E3 */ 4,
  /* 36 F3 */ 3,
  /* 37 G3 */ 2,
  /* 38 H3 */ 1,
  /* 39    */ 0,

  /* 40    */ 0,
  /* 41 A4 */ 2,
  /* 42 B4 */ 3,
  /* 43 C4 */ 4,
  /* 44 D4 */ 5,
  /* 45 E4 */ 5,
  /* 46 F4 */ 4,
  /* 47 G4 */ 3,
  /* 48 H4 */ 2,
  /* 49    */ 0,

  /* 50    */ 0,
  /* 51 A5 */ 3,
  /* 52 B5 */ 4,
  /* 53 C5 */ 5,
  /* 54 D5 */ 6,
  /* 55 E5 */ 6,
  /* 56 F5 */ 5,
  /* 57 G5 */ 4,
  /* 58 H5 */ 3,
  /* 59    */ 0,
	
  /* 60    */ 0,
  /* 61 A6 */ 4,
  /* 62 B6 */ 5,
  /* 63 C6 */ 6,
  /* 64 D6 */ 7,
  /* 65 E6 */ 7,
  /* 66 F6 */ 6,
  /* 67 G6 */ 5,
  /* 68 H6 */ 4,
  /* 69    */ 0,

  /* 70    */ 0,
  /* 71 A7 */ 5,
  /* 72 B7 */ 6,
  /* 73 C7 */ 7,
  /* 74 D7 */ 8,
  /* 75 E7 */ 8,
  /* 76 F7 */ 7,
  /* 77 G7 */ 6,
  /* 78 H7 */ 5,
  /* 79    */ 0,

  /* 80    */ 0,
  /* 81 A8 */ 6,
  /* 82 B8 */ 7,
  /* 83 C8 */ 6,
  /* 84 D8 */ 9,
  /* 85 E8 */ 9,
  /* 86 F8 */ 8,
  /* 87 G8 */ 7,
  /* 88 H8 */ 6,
  /* 89    */ 0,

  /* 90    */ 0,
  /* 91    */ 0,
  /* 92    */ 0,
  /* 93    */ 0,
  /* 94    */ 0,
  /* 95    */ 0,
  /* 96    */ 0,
  /* 97    */ 0,
  /* 98    */ 0,
  /* 99    */ 0	

};
/**********************************************************************************/
/* second version  note for piece position                                        */
/* Mark (note) each  position of pieces depending on situation                    */
/**********************************************************************************/
typedef  const char def_not_pos;
typedef def_not_pos tdef_not_pos[100];
typedef def_not_pos * tptdef_not_pos[3];
typedef def_not_pos ** ptptdef_not_pos;

/* type of situation : opening,middle game, end game */
enum e_sit_typ_not_pos
  {
    opn_gam,
    mid_gam,
    end_gam,
    NBR_SIT_TYP
  };



/**********************************************************************/
/*  structure enum type def for global data                           */
/**********************************************************************/
/* fonction mouvement */
typedef void (*tpf_xxx)(void);
typedef void (*def_tpf_res_pie) (void);
typedef int (*def_tpf_cas_ctl[19])     (int n,int i_cam_adv);
typedef const int def_ti_ech_dir_rei[100][100];
typedef const int def_ti_ech_dir_tou[100][100];
typedef const int def_ti_ech_dir_fou[100][100];
typedef const int def_ti_ech_dir_cav[100][100];
typedef const int def_ti_ech_dir_roi[100][100];
typedef const int def_ti_ech_dir_pio_noi[100][100];
typedef const int def_ti_ech_dir_pio_bla[100][100];
typedef const int def_ti_ech_dir_inc[100][100];

typedef void (*def_pf_not_cal)(void);
struct st_ver
{
  int (*pf_eva) (void);
  int i_pro_sim_niv;
  int i_pro_sim_inc;
  char * ptc_lib;
  int i_ran_cho_max;
};

enum e_ver
{ 
  V00,
  V01,
  V02,
  LOW1,
  MEDIUM1,
  HIGH1,
  VER_NBR
};
int i_cot_aff;
int i_side;
int i_first_time_init;
/*   tableau des pièces un par camp  */
/* opti: voir si un seul tableau possible */
struct st_pie
{
  int i_Id;				/* Id de la piece */	
  int i_pie_sui;		        /* pièce suivante */
  int i_pie_pre;                        /* pièce precedente  */
  int i_pos_n;                          /* position échiquier  */
  int i_for; 			        /* force  */
  int i_big_inc_ene;                    /* force incrementé pour eviter sacrifice inutile de piece */
  int i_big_inc_pro;                    /* force incrementé pour eviter sacrifice inutile de piece */
  int i_lit_inc_ene;                    /* force incrementé pour eviter sacrifice inutile de piece */
  int i_lit_inc_pro;                    /* force incrementé pour eviter sacrifice inutile de piece */
  char c_lib_pie;			/* Libelle piece  */
  char c_typ_pie;			/* Type  piece  */
  void (*pf_ini_hst_mvt) (void);	/* ptr sur fonction in_mvt_XXX   */
  int (*pf_jou)  (char c_rem_pio);	/* ptr sur fonction joue pièce	 */      
  int (*pf_ech_par) (int n,int nr);     /* ptr sur fonction echec par  */
  int (*pf_ctl_par) (int n,int nr);     /* ptr sur fonction cas_tl_xxx  */
  defv_bool defv_mvt_uni_dir ;    	/* mvt unique pour direction   */
  defv_bool defv_typ_mvt_tou ;          /* type de mvt selon colone oui = 1 pour reine et tour */   

  defv_bool defv_typ_mvt_fou ;          /* type de mvt selon oblique oui= 1 pour reine et fou */

#ifdef INC_POS_NOT
  def_inc_not  *def_ptc_inc_not;        /* pointer on the table used to increment the mark (note) */
                                        /* this pointer is loaded in pro_sui                      */
#endif
  ptptdef_not_pos  ptptdef_not_pos_pie; /* table containing pointer on table not_pos */

};

/* tableau echiquier accès par l'emplacement  */
struct st_ech
{
  int i_cam;
  /* opti perf: pourrait peut etre utiliser une adresse sur piece */ 
  int i_Id;
};



/* Table des messages utilisateur */
/*char tc_msg_txt[NBR_MSG][LEN_MES];*/
typedef char *def_tptc_msg[MSG_NBR];

/* strucuture parametre messages */
struct st_par
{
  int i_nbr_par;                /* nombre de parametres */
  char tc_par_mes [NBR_MAX_PAR_MES][LON_MAX_PAR_MES];
};

enum {e_pas_aff,e_aff_not_1,e_aff_not_2,st_aff_dim} e_cur_aff;		/* affichage en cours */

/* used be able to print result in several page  with teletype mode */
struct st_aff
{
  int i_nbr_lig_pag;
  int i_cur_pag;
  int i_fir_pag;
  int i_las_pag;
  int (*pf_aff)();
  void * arguments;
};

/* structure used to register the allocated memmory (as an index) */ 
struct st_ind
{
  void * pv_mem;               /* pointer on the memory registered*/
  struct st_ind *pst_pre_ind;  /* link to previous index*/
} ;

#ifdef UPLOAD_BRANCHE  
/*  */

struct  st_bra_nod
{
  char i_pos_n;                 	/* ariving square*/
  char i_typ_mvt;		        /* moe type  */
  char i_pos_ori_n;                     /* departure square */
  struct st_bra_nod *pst_nxt_nod;       /* next _subsequent node (move)*/
};

struct st_branche
{  

  long  li_ini_nod_qua;                   /* initial node quantity  */
  long  li_tot_nod_nbr;                   /* total number of nodes in all blocks */
  int   i_inc_per;                        /* increment percentage when a block i full */

  long  li_byt_siz;                       /* total size in byte for all blocks*/
  int   i_tot_inc_nbr;                    /* total number of increment used */

  struct st_bra_nod * pst_blo_beg;        /* beginnning of memory block */
  struct st_bra_nod * pst_blo_end;        /* end of  memory block */
  struct st_bra_nod * pst_fre_new_nod;    /* next free node to use  */

  struct st_bra_nod * pst_fre_old_nod;    /* head of the garbage collector */
  struct st_bra_nod * pst_las_old_nod;    /* tail of the garbage collector */

  struct st_bra_nod * pst_nxt_fre_nod;    /* next free node to use  */

  struct st_ind * pst_ind;                /* memory block liste   */

};

#endif
/* the data used to construct maintain  and acces the hash  */
struct st_hash {

  struct st_arr * pst_arr_beg;      /* beginnning of memory for arriving field */
  struct st_arr * pst_arr_end;      /* end  memory for arriving field */
  struct st_arr * pst_arr_fre;      /* next free bloc to use  */

  struct st_dep * pst_dep_cur_l1;   /* current movment at level one */
  struct st_dep * pst_dep_cur_l2;   /* current movment at level two */
  struct st_dep * pst_dep_cur_l3;   /* current movment at level three */

  struct st_dep * pst_dep_beg;      /* beginnning of memory for departure field */
  struct st_dep * pst_dep_end;      /* beginnning of memory for departure field */
  struct st_dep * pst_dep_fre;      /* next free bloc to use */
  struct st_ind * pst_ind;          /* memory block liste   */

  int   i_mvt_qua_ave;              /* initial node quantity at the top of the tree */
                                    /* its the number of initial move             */
                                    /* used as a base to compute the total node quantity*/
                                    /* for each blocs dep and arr                       */
  int   i_inc_per;                  /* increment percentage when a bloc i full */
  long  li_mvt_qua_tot;              /* movement quantity average for ech level  soon deprecated */
  long  li_dep_mov_qua;              /* inial node quantity use for the bloc dep  */
  long  li_arr_mov_qua;              /* inial node quantity use for the bloc arr  */

  long  l_dep_siz;                  /* size in byte of bloc depart */
  int   i_dep_inc_nbr;              /* number of increment in bloc depart */
  long  l_dep_seg_nbr;              /* number of segment in bloc depart */

  long  l_arr_siz;                  /* size in byter of bloc arriving*/
  int   i_arr_inc_nbr;              /* number of increment in bloc arriving */
  long  l_arr_seg_nbr;              /* number of segment in bloc arriving */

  long  l_nbr_bra_fou;              /*number of banche found in the hash */
                                    /*its also the number of move at level 3 */
  long  l_nbr_bra_sek;              /*number of move seeked  in the hash */

};

/* st_dep f  */
struct st_dep
{ 
  int i_dep;                        /* Departure field */
  int i_typ_mvt;                    /* Type of move */
  struct st_arr  * pst_arr_nxt_lev; /* pointer on the movement in next*/
                                    /* depth-level or the datas colected  */
  struct st_dep * pst_nxt_dep;      /* pointer on the next movement having */
                                    /*the same arriving  field at same depth-level */
  int i_not;
  int i_typ_pri_lea;                /* if thereis a taken on the leaf node */
                                    /* uploaded with the best note */
#ifdef UPLOAD_BRANCHE  
  struct st_bra_nod *pst_not_max_bra_hea;  /* first move of the list for the not_max branche*/ 
  struct st_bra_nod *pst_not_max_bra_las;  /* last  move of the list for the not_max branche*/ 
#endif

};


/* tableau historique des coups */
struct st_hst_pro
{
  int i_pro;			        /* profondeur pour test du ptr pts_hst_pro 0= debut de partie */
  int i_dec_mat;		        /* décrement pour la note mat */
  defv_bool defv_exp_par;               /* rester au même niveau si deplacement suit une prise */
  const  tpf_xxx *ptpf_mvt;	        /* ptr sur fonction  mouvement */
  int i_cam;    	 	        /* camp	*/
  struct st_pie *pts_pie_pc;            /* pointeur sur piece propre camp  */        
  defv_bool defv_ene;                   /* Yes if adversary */
  int i_cam_adv;	         	/* camp	 adverse */
  struct st_pie *pts_pie_ca;            /* pointeur sur piece camp adverse */
  int i_Id;                 	        /* Idetifiant pièce */
  /* opti : voir si stockage de l'adresse serait pas plus performant */
  int i_pos_n;                 	        /* pos. échiquier*/
  int i_typ_mvt;		        /* type mouvement */
  defv_bool defv_dir_sui;		        /* direction suivante*/
  int i_pos_ori_n;                      /* pos. origine	*/
  int i_Id_2p;                          /* Id deuxième pièce */
  int i_pos_n_R_p_c;	                /* Position n roi propre camp	*/
  int i_pos_n_R_c_a;	                /* Position n roi camp	adverse	*/
  defv_bool defv_ech ;		        /* echec par pièce principale 
                                           ou secondaireou par demasquge */
  int i_ech_dir_pri;	                /* dir. pièce principale ou secondaire
                                            causant echec sur camp adverse
				           (si valeur  <> 0 alors echec) */
  int i_ech_dir_dem;	                /* dir.demasaquage causant eventuel
				           echec sur camp  adverse  */
  int i_ech_dir_dem_p_c;                /* direction demasaquage causant echec	
				           sur propre camp  */
  defv_bool defv_pat ;    	         	/* pat   */
  defv_bool defv_mat ;	        	/* mat 	*/
  /*  int ti_not[2];  */                /* note par camp */
  int i_not;		        	/* note */
  int i_typ_mvt_pri_lea;	        /* type of move at the leaf */
  int i_not_max;		        /* note maximum */
  int i_not_max_typ_mvt_pri_lea;        /* type of move at the leaf for not max */
  int i_rap_for;                        /* rapport de force à zero en debut de simu */
  int ti_roc_cam_typ[2][2];             /* [cam][type] type: 0= petit 1= grd 
                                           Si = 1 alors piece deplacé
                                           bug Suppression non signalé*/
  unsigned long int uli_cpt_cou;        /* Compteur de coup */
  unsigned long int uli_cpt_mat;        /* Compteur de mat */
  unsigned long int uli_cpt_pat;        /* Compteur de pat */
  unsigned long int uli_cpt_mat_rf;     /* Compteur de mat rapport de force = 0 */
  unsigned long int uli_cpt_pat_rf;     /* Compteur de pat rapport de force = 0 */
  unsigned long int uli_nbr_fou;        /* Compteur de fouchettes */
  int i_nbr_pri_pie;                    /* Compteur de prises faites par une piece 
				           raz à chaque chgt de piece */
  /* variable test */
# if CPT_ITE == 1
  unsigned long int cpt;
# endif
#ifdef STHASH1  

  int i_sto_res_hash_nbr;                /* hash number to use with sto_res()*/
  defv_bool defv_store_result;           /* do not store if FALSE */

                                         /* do not call if < 0 */
  int i_mem_hash_nbr;                    /* indexe used to access the table of struct st_hash*/
                                         /* used as argument with fre_mem() and ini_mem()*/
                                         /* do not call if < 0 */

  int i_nbr_ele_tpf_hash;                /* number of element in *tpf_hash*/
  int ti_arg_fct_hash_add[NBR_MAX_HASH]; /* argument to pass to fct add hash */
  int (*tpf_hash_add [NBR_MAX_HASH])     /* list of functions to call to maintain */ 
        (struct st_hash *tpst_hash);     /* all the hash table */ 
  
#endif
#ifdef STHASH  
        			    
    int (*pf_hash_add_lx)(struct st_hash *pst_hash1); /* deprecated */ 
#endif
#ifdef UPLOAD_BRANCHE  
  struct st_bra_nod *pst_not_max_bra_hea;  /* first move of the list for the not_max branche*/ 
  struct st_bra_nod *pst_not_max_bra_las;  /* last  move of the list for the not_max branche*/ 
#endif

};
/* Type de note pour mise en tableau */
enum typ_not
{
  nbr_mvt,
  nbr_mat,
  nbr_mat_inc,
  nbr_pat,
  nbr_pat_inc,
  nbr_mat_rf,
  nbr_pat_rf,
  nbr_fou,
  mob_pie,
  cou_pie,
  pos_pie,
  NBR_TYP_NOT 
};

/* tableau note du mvt initial */
#define ST_NOT_MVT_INI   struct	 st_not_mvt_ini  
struct st_not_mvt_ini
{
  int 	i_num_mvt;	/* Numero du mvt */
  int   i_pro_sim;		/* profondeur de simulation */	 
  int	i_inc_pro_sim;		/* incrément profondeur de simulation*/
  int 	i_cam;	  	/* cam propre */
  int 	i_cam_adv;	/* cam adverse*/
  int 	i_Id;		/* pièce mouvemente*/
  char 	c_lib_pie;      /*  libelle piece*/
  int 	i_typ_mvt;	/* type mouvement */
  int 	i_typ_mvt_pri;	/* type mouvement prise */
  int 	i_pos_ori_n;    /* pos d'origine échiquier */
  int 	i_pos_arr_n;    /* pos arrivee échiquier*/
  int 	i_nbr_rep_sit;  /* Nombre de répétition situation */
  int   i_not_pri;	/* Note prise */
  int   i_typ_mvt_pri_lea; /* A taken is done on the leaf node */

  
  /* struct st_hst_pro_sta 	*/	/* statistique par profondeur */
  /*tst_pro_sta[PRO_SIM_INF_MAX]; */	/* marge de 1 poste car profondeur de depart */

  struct st_not
  {
    float f_not_cam_bru[2];  /* donnée cumulée brute(cad non pondérée) */
    float f_not_cam_pon[2];  /* note pondrée par camp  */
    float f_not_dif_pon;     /* difference pondérée pc-ca pond */
    int   i_not_pon_rec;     /* fifférence pondérée et recadrée  */
  } tst_not[NBR_TYP_NOT];

  /* Note globale */
  float f_tot_dif_pon;		/* total pondéreé de la note non recadrée */
  float	f_tot_rec_pon;       	/* total pondéré de la note recadrée */ 
#ifdef UPLOAD_BRANCHE  
/*  */
  struct st_bra_nod *pst_bra_nod;
#endif

};
/* structure pour evaluation rapport de force */
struct st_eva_sit
{
  int    ti_tot_for[2];        /* Totalisation force des piece par camp */
  int    i_not_for;            /* Force pc - ca */
  float  tf_cou[2];            /* Evaluation couverture par camp avant mouvement */
  float  f_cou;                /* cou pc - cou ca */
  float  tf_mob[2];             /* mobilité par camp */
  float  f_not_mob;              /* mob pc- mob ca */
  /* Pondération ou ordre de tri */
  int ti_coe_pon[NBR_TYP_NOT];

  /* maximum /minimu rencontrée ds la selction des meilleurs mvts pour cal note recadrée */

  struct st_int_not
  {
    float max;
    float min;
  } tst_int_not[NBR_TYP_NOT];


};

/* Sous structure de not_mvt_ini pour evaluation mat/pat par profondeur */
struct st_hst_pro_sta	
{
  int i_cam;				/* Camp jouant a cette  pro	*/
  int i_inc;				/* Si increment profondeur = 1	*/
  float f_dat_pro [NBR_TYP_NOT];	/* Data par profondeur  non pondéré */
};


/* indexe pour retrier les mouvement */
struct st_tri_mvt_ini
{
  ST_NOT_MVT_INI *pts_tri_rec;

};

/* Memorisation de position des pieces detecter les cas de partie nulle */
struct st_pos
{
  int i_pos_n [2][17];		/* position cam Id  */
  int ti_roc_cam_typ[2][2];     /* [cam][type] type: 0= petit 1= grd */
  int i_cam_jou;		/* Camp qui doit jouer */
  /* info pour éviter de tester l'ensemble des pieces */
  int i_nbr_pie[2];		/* Nombre de piece par camp */
  int i_som_pos[2];		/* Somme des positions */
  int i_nbr_pie_tot;		/* Nombre de pieces total */
  int i_som_pos_tot;		/* Somme des position */
};

/* to avoid multiple inclusion of this entire file */
#endif
