/*   
    
    Chess-Ec  Vers      Copyright (C)   2001-2008 Marc Dechico

    ec_init.h : all initialisation needed by the application 
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 37 98 22 54
				Mail: ec@chess-ec.org  
    
*/


#include "ec_global.h"

/*****************************************************************************/
/* external function  */
/*****************************************************************************/


extern int ech_par_pio_0   (int n, int nr);
extern int ctl_par_pio_0   (int n, int nr);
extern int ech_par_pio_1   (int n, int nr);
extern int ctl_par_pio_1   (int n, int nr);
extern int ech_par_cav     (int n, int nr);
extern int ctl_par_cav     (int n, int nr);
extern int ech_par_tou     (int n, int nr);
extern int ctl_par_tou     (int n, int nr);
extern int ech_par_fou     (int n, int nr);
extern int ctl_par_fou     (int n, int nr);
extern int ech_par_rei     (int n, int nr);
extern int ctl_par_rei     (int n, int nr);
extern int ctl_par_rei     (int n, int nr);
extern int ech_par_roi     (int n, int nr);
extern int ctl_par_roi     (int n, int nr);


/* initialise en pion */
extern  void set_pie_pio(void);		
extern  void set_pie_pio_blanc(void);
extern  void set_pie_pio_noir(void);

/* initialise en cavalier */
extern  void set_pie_cav(void);		
extern  void set_pie_cav_blanc(void);
extern  void set_pie_cav_noir(void);

/* initialise en tour */
extern  void set_pie_tou(void);			
extern  void set_pie_tou_blanc(void);
extern  void set_pie_tou_noir(void);

/* initialise en fou */
extern  void set_pie_fou(void);			
extern  void set_pie_fou_blanc(void);
extern  void set_pie_fou_noir(void);

/* initialise en reine */
extern  void set_pie_rei(void);			
extern  void set_pie_rei_blanc(void);
extern  void set_pie_rei_noir(void);

/* initialise en roi */
extern  void set_pie_roi(void);		
extern  void set_pie_roi_blanc(void);
extern  void set_pie_roi_noir(void);

/* initialisation hst avec pointeur sur tableau de fct mvt */
extern void ini_hst_mvt_roi     (void);
extern void ini_hst_mvt_rei     (void);
extern void ini_hst_mvt_tou     (void);
extern void ini_hst_mvt_fou     (void);
extern void ini_hst_mvt_cav     (void);
extern void ini_hst_mvt_pio_0   (void);
extern void ini_hst_mvt_pio_1   (void);

/* eva init fonction rans ()*/
extern void  seed_ran_cho (void);

/* ec_jou */
extern void sav_pos (int i_pro);			/* sauvegarde du trait */
extern int jou_pio_0 		(char c_rem_pio); 	/* joue pion blanc */
extern int jou_pio_1 		(char c_rem_pio); 	/* joue pion noir  */
extern int jou_ctfr		(char c_rem_pio); 	/* joue cavalier tour fou reine */
extern int jou_roi 		(char c_rem_pio);	/* joue roi*/
extern int ini_dsk(void);

/*eva*/
extern int 	eva_mei_mvt_01	(void);		       	/* retourne meilleur mouvement */
extern int 	eva_mei_mvt_02	(void);		       	/* retourne meilleur mouvement */
extern int 	eva_mei_mvt_03	(void);		       	/* retourne meilleur mouvement */


/*****************************************************************************/
/* external data  */
/*****************************************************************************/

/* piece camp 0	*/
extern struct st_pie ts_pie_0[18];
			
/* piece camp 1	*/
extern struct st_pie ts_pie_1[18];
			
/* tableau pointant sur piece camp 0 ou 1 */
/* poste 0 camp 0, 1 camp 1 */
extern struct st_pie *tpts_pie[2];
		        
/* tableau touver ID piece roi camp [0/1] */                                                        
extern int Id_roi[2];                      
             
/* tableau pour trouver position du roi partir du camp */
extern int *pts_pie_pos_Roi[2];                         

 /* tableau echiquier acces par l'emplacement  */
extern struct st_ech ts_ech[100];             
         
 /* tableau historique des coups */
extern  struct st_hst_pro ts_hst_pro[PRO_HST];         
 /* Tableau donnant l'ID de la tour suivant le roc et le cam */
/* Camp: NOIR/BLANC Typ GRA_ROC/PET_ROC */
extern int ti_tou_cam_typ[2][2];                       


extern tptdef_not_pos tptdef_not_pos_pawn ;
extern tptdef_not_pos tptdef_not_pos_knight ;
extern tptdef_not_pos tptdef_not_pos_bishop ;
extern tptdef_not_pos tptdef_not_pos_rook ;
extern tptdef_not_pos tptdef_not_pos_queen ;
extern tptdef_not_pos tptdef_not_pos_king ;

 /* Table des messages utilisateur */
def_tptc_msg tptc_msg;                                 
 /* Numero d'evaluation  */
extern  int i_ver_eva;		
/* pointeur sur fonction évaluation */		       
extern int (*pf_eva) (void);  			       
 /* tableau pointeur sur fonction évaluation */ 
extern int (*tpf_eva[100]) (void);  		       
/* =1 si affichage note possible */
extern defv_bool defv_aff_not_pos;                          
 /* = 1 si affichage calcul en cour */
extern defv_bool defv_aff_cal_cou;			
/* profondeur actuelle	*/       
extern int i_pro_act;                                  
 /* ptr sur tbl structure pièce principale*/ 
extern struct st_pie  		*pts_pie;      	       

/*****************************************************************************/
/* local  function  */
/*****************************************************************************/
void    	ini_pgm 	(void);
static void 	ini_msg 	(void);

static void 	ini_sim 	(void);                 /* initialisation necessaire pour la simulation */

static void 	ini_pie 	(void);                 /*initialisation des tableaux pieces */

static int 	ini_hst 	(int i_cam_hst_0);      /* initialisation du tableau historique */

static void 	ini_ech 	(void);                 /* initialisation du tableau echiquier */

static void 	ins_pie_01	(void);                 /* installation des piece en début de partie */
static int 	ajo_pie 	(int i_cam,char c_cod_pie,int i_pos_n);


/*****************************************************************************/
/* local  data  */
/*****************************************************************************/
/*Variable de travail locale du module  */
static int    nn;				 /* position pièce 				 */



