/*   
    
Chess-Ec     Copyright (C)   2001-2008 Marc Dechico

ec_jou.c : 	function used to let the user (check validity of the move) 
or to let the computer  move pieces after evaluating the best move 
	       
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

To contact the author:	
Marc Dechico
Kerfring
29390 SCAER France
tel: 06 37 98 22 54
Mail: ec@chess-ec.org  
    
*/

#include "ec_jou.h"

/* joue interactif + reponse ordinateur  */
int jou_int_jou	 (char *ptc_dep,		
		  char *ptc_arr)
{
  int i_msg;
  i_msg=jou_int_ctl(ptc_dep,ptc_arr);
  if(i_msg<0)/* erreure ou mat*/
    return i_msg;
  else
    return (sim_jou());
  
}

/* joue interactif + controle echec  */
int jou_int_ctl	 (char *ptc_dep,		
		  char *ptc_arr)
{
  int i_msg;	   

  i_msg=jou_int(ptc_dep,ptc_arr);
  if(i_msg<0) return i_msg;  /* Erreur mouvement */
  //  sav_dsk("ec.wrk");
  return ( simul_ctl());
	
}
/* jou interactif */
int jou_int (char *ptc_dep,char *ptc_arr)
{
  int i_pos_dep_x;
  int i_pos_dep_y;
  int i_pos_arr_x;
  int i_pos_arr_y;

  int i_pos_dep_n;
  int i_pos_arr_n;
	
  char c_tpie_rpio;
	
  /* tst */
  /*printf ("dep:%s arr:%s",ptc_dep,ptc_arr);*/

  /* traduction position en coordonnée */
  i_pos_dep_x = tra_col(*(ptc_dep));
  if (i_pos_dep_x == 0)
    {
      /*colonne position de depart invalide*/;
      return  -MSG_JOU_INT_COL_DEP_INV ;
    }
  i_pos_dep_y = tra_lig(*(ptc_dep+1));
  if (i_pos_dep_y == 0)
    {
      /* ligne position de depart invalide*/
      return -MSG_JOU_INT_LIG_DEP_INV;
    }


  i_pos_arr_x = tra_col(*(ptc_arr));
  if (i_pos_arr_x == 0)
    {
      /* colonne position d'arrive invalide*/
      return -MSG_JOU_INT_COL_ARR_INV;
    }

  i_pos_arr_y = tra_lig(*(ptc_arr+1));
  if (i_pos_arr_y == 0)
    {
      /* ligne position d'arrive invalide */
      return -MSG_JOU_INT_LIG_ARR_INV;
    }
  /* Recupere libelle piece de remplacement pour pion et traduit en type piece  */
  c_tpie_rpio =pro_pio_tra_lpie_tpie( *(ptc_arr+2));

  i_pos_dep_n= i_pos_dep_y *10 + i_pos_dep_x;
  i_pos_arr_n= i_pos_arr_y *10 + i_pos_arr_x;

  return (jou (i_pos_dep_n,i_pos_arr_n, c_tpie_rpio));
	

}
/* joue    						  */
int jou(	int i_pos_dep_n,
		int i_pos_arr_n,
		char c_tpie_rpio
		)

{
  int i_msg;
  int i_cam_pie=ts_ech[i_pos_dep_n].i_cam;
  int i_cam_tou= ts_hst_pro[i_pro_act+1].i_cam;

  /* organisation  ajoute test pour eviter des acces hors tableau */
  /* pas de pièce */
  if (ts_ech[i_pos_dep_n].i_cam == VIDE)
    {
      /*Pas de pièce à cette position*/;
      return -MSG_JOU_PAS_DE_PIE;
    }

  /* camp invalide */
  if (i_cam_pie   != i_cam_tou)
    {
      /*Tour aux %s: Cette piece est noire*/;
      st_par_mes.i_nbr_par=2;
      if (i_cam_pie == BLANC)
	{
	  strncpy(st_par_mes.tc_par_mes[0],_(tptc_msg[ MSG_LIB_BLANC ]),LON_MAX_PAR_MES );
	  strncpy(st_par_mes.tc_par_mes[1],_(tptc_msg[ MSG_LIB_NOIR ]),LON_MAX_PAR_MES );
	}
      else
	{
	  strncpy(st_par_mes.tc_par_mes[0],_(tptc_msg[ MSG_LIB_NOIR ]),LON_MAX_PAR_MES );
	  strncpy(st_par_mes.tc_par_mes[1],_(tptc_msg[ MSG_LIB_BLANC ]),LON_MAX_PAR_MES );
	}

      return -MSG_JOU_PAS_VOT_TOU;
    }


  /* prise pièce propre camp invalide */
  if (ts_ech[i_pos_arr_n].i_cam
      ==
      ts_hst_pro[i_pro_act+1].i_cam)
    {
      /*Prise pice propre camp imposible*/;
      return -MSG_JOU_PRI_PRO_CAM;
    }

	
  jou_pro_sui(i_pos_dep_n,i_pos_arr_n);
	
  /* appell fonction joue propre à la pièce */
  i_msg =((*(pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id)->pf_jou)(c_tpie_rpio));

  /* sauvegarde de la position si pas d'erreur */
  if (i_msg ==0) 
    {
      sav_pos(i_pro_act);
      if (ctl_rep_pos(i_pro_act)>=3)
	/* Position  reproduite + de 3 fois egalité ? */
	return -MSG_JOU_POS_REP_P3F;
    }
	
  return i_msg;

}
void jou_pro_sui(int i_pos_dep_n,int i_pos_arr_n)
{

  /* initialiasation historique  pour coup suivant */

  i_pro_act++;

  /* initialisation du  pionteurs sur hst */
  pts_hst_pro 	= &ts_hst_pro[i_pro_act];
  pts_hst_pro_p 	= &ts_hst_pro[i_pro_act-1];

  /* raz not_max */
  pts_hst_pro->i_not_max			= NOT_MIN;

  /* descente et maj du rapport de force */
  /* opti:  initialiser pointeur sur piece de chaque camp dans hst */ 
  /* opti: test du type de mvt inutle car si pas e prise alors note = 0 (a verifier)*/
  if (ti_typ_mvt_pri[pts_hst_pro_p->i_typ_mvt])
    pts_hst_pro->i_rap_for = -(pts_hst_pro_p->i_rap_for
			       +
			       pts_hst_pro_p->i_not
			       );
  else
    pts_hst_pro->i_rap_for = -pts_hst_pro_p->i_rap_for;

  /* renseigne hst */
  pts_hst_pro->i_Id =ts_ech[i_pos_dep_n].i_Id;
  pts_hst_pro->i_pos_ori_n = i_pos_dep_n;
  pts_hst_pro->i_pos_n = i_pos_arr_n;
	
  /* charge hst avec pos roi camp propre et adverse */
  hst_pos_roi();

  /* initialisation du  pionteurs piece actuelle  */
  pts_pie =
    /*	tpts_pie[pts_hst_pro->i_cam]+pts_hst_pro->i_Id;*/
    pts_hst_pro->pts_pie_pc + pts_hst_pro->i_Id;

#ifdef INC_POS_NOT
  /* link the piece to the right inc not table */
  /* next step using a table indexed on the depth (pro)*/
  if (pts_pie->c_typ_pie == 'P')
    pts_pie->def_ptc_inc_not=def_tc_inc_pawn;
  else
    pts_pie->def_ptc_inc_not=def_tc_inc_not_pawn;
#endif

  /* calcul echec par demasquage sur roi camp adverse */
  /*ech_cal_dir_dem  (	pts_hst_pro->i_cam_adv,
    &(pts_hst_pro->i_ech_dir_dem));*/
  ech_cal_dir_dem_ca();
  /* calcul echec par demasquage sur roi propre camp   */
  /*ech_cal_dir_dem  (	pts_hst_pro->i_cam,
    &(pts_hst_pro->i_ech_dir_dem_p_c));*/
  ech_cal_dir_dem_pc();

}

/* traduit colonne   */
int tra_col (char c_col)
{
  /* org  something to do for the traduction */
  switch (tolower (c_col))
    {
    case 'a':
      return 1;

    case 'b':
      return 2;

    case 'c':
      return 3;

    case 'd':
      return 4;

    case 'e':
      return 5;

    case 'f':
      return 6;

    case 'g':
      return 7;

    case 'h':
      return 8;

    default:
      return 0;
    }
}

/* traduit colonne   */
int tra_lig (char c_lig)
{
  /* org something to do for the traduction */

  switch (c_lig)
    {
    case '1':
      return 1;
    case '2':
      return 2;
    case '3':
      return 3;
    case '4':
      return 4;
    case '5':
      return 5;
    case '6':
      return 6;
    case '7':
      return 7;
    case '8':
      return 8;
    default:
      return 0;
    }
}

/* joue roi						  */
int jou_roi (char c_tpie_rpio)	/*rem_pio pas utilisé dans cette fct */
{
  int i_Msg;
  /* seulement pour éviter warning */
  if (c_tpie_rpio == 'x')
    c_tpie_rpio =' ';

  /* mouvement de type roc */

  if  	/* si petit petit rock blanc demand */
    (
     pts_hst_pro->i_pos_ori_n	==E1
     &&
     pts_hst_pro->i_pos_n	==G1
     )	
    return jou_pet_roc_0();	
  else

    if  	/* si petit petit rock blanc demand */
      (
       pts_hst_pro->i_pos_ori_n	==E8
       &&
       pts_hst_pro->i_pos_n		==G8
       )
      return jou_pet_roc_1();
    else
	
      if    	/* si grd rock blanc demand */
	(
	 pts_hst_pro->i_pos_ori_n	==E1
	 &&
	 pts_hst_pro->i_pos_n	==C1
	 )
	return jou_grd_roc_0();
      else
	
	if    	/* si grd rock noir demand */
	  (
	   pts_hst_pro->i_pos_ori_n	==E8
	   &&
	   pts_hst_pro->i_pos_n		==C8
	   )
	  return jou_grd_roc_1();


  /*Test delta x et y pour valider deplacement */
  i_Msg=ctl_mvt_roi();
  if(i_Msg!=0)
    {
      pro_pre();
      return i_Msg;
    }

  /* mouvement autre que roc */

  if  	/* prise simple de pièce */

    (ts_ech[pts_hst_pro->i_pos_n].i_cam
     ==
     pts_hst_pro->i_cam_adv)
    {

      pts_hst_pro->i_typ_mvt = ROI_PRI;
      pri_sim();

    }
  else    /* deplacement simple */
    {

      pts_hst_pro->i_typ_mvt = ROI_DEP;
      dep_sim();
      /* preserve possibilié de roc  */
      if (!(	    
	    pts_hst_pro->ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]
	    ||
	    pts_hst_pro->ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]
	    )
      	  )
      	pts_hst_pro->i_not = NOT_ROC_TOU;


    }
  if (ctl_par_xxx(pts_hst_pro->i_pos_n))
    {
      ann_cou();
      /*Le roi se retrouve echec mvt impossible*/;
      return 	-MSG_JOU_ROI_ROI_ECH;
    }
  else
    {
      /* roi ne se retrouve pas echec donc pat = N  */
      pts_hst_pro_p->defv_pat = N;
      /* verifie si cause echec camp adverse */
      /* par par demasquage*/
      if
	(
	 pts_hst_pro->i_ech_dir_dem
	 &&
	 (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem])
	 (pts_hst_pro->i_pos_n_R_c_a,
	  pts_hst_pro->i_cam)

	 )
	{
	  set_ech_on();
	}
      else
	{
	  set_ech_off();
	}

      /* petit et grd rock plus possible */
      (pts_hst_pro+1)->
	ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]= 1;

      (pts_hst_pro+1)->
	ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]= 1;

      /* recopie valeur grd et petit rock pour cam adverse */
      cop_val_jou_prc_ca();
      cop_val_jou_grc_ca();


    }
  return 0;
}
int jou_grd_roc_0 	(void)
{	
  if
    (
     ts_ech[E1].i_cam!=BLANC
     ||
     ts_hst_pro[i_pro_act-1].
     ti_roc_cam_typ[BLANC][GRA_ROC]!=0
     )
    {
      pro_pre();
      /*Grand rock plus possible*/;
      return -MSG_JOU_ROI_GRD_ROC_IMP;
    }
		
  /* blanc */
  if
    (
     pts_hst_pro->
     ti_roc_cam_typ[BLANC][GRA_ROC]		 /* roi ou tour deplace */
     ||
     ts_ech[A1].i_Id!=
     ti_tou_cam_typ[BLANC][GRA_ROC]		 /* tour supprime car pas deplace*/
     ||
     pts_hst_pro_p->defv_ech				 /* echec prof precedente */
     ||
     ts_ech[B1].i_cam!=VIDE		   	 /* case intermedaire  non vide*/
     ||
     ts_ech[C1].i_cam!=VIDE
     ||
     ts_ech[D1].i_cam!=VIDE
     ||
     ctl_par_xxx	(B1)        /* ou sous ctl adversaire */
     ||
     ctl_par_xxx     (C1)
     ||
     ctl_par_xxx	(D1)
     )
    {
      pro_pre();
      /*Grand rock impossible*/;
      return -MSG_JOU_GRD_ROC_ROC_IMP;
    }
  else					/* roc possible */
    {
      pts_hst_pro->i_typ_mvt = ROI_GRA_ROC;                /*grd rock */
      pts_hst_pro_p->defv_pat = N;                 /* pas d'echec poss*/
      dep_grd_roc_0();                            /* mvt des pices */
      jou_mvt_roi_roc(D1);
    }
  return 0;
}
int jou_grd_roc_1 	(void)
{
  if
    (
     ts_ech[E8].i_cam!=NOIR
     ||
     ts_hst_pro[i_pro_act-1].
     ti_roc_cam_typ[NOIR][GRA_ROC]!=0
     )

    {
      pro_pre();
      /*Grand rock plus possible*/;
      return -MSG_JOU_ROI_GRD_ROC_IMP;
    }
	
  /* noir */
  if
    (
     pts_hst_pro->
     ti_roc_cam_typ[NOIR][GRA_ROC] 	     /* roi ou tour deplace */
     ||
     ts_ech[A8].i_Id!=
     ti_tou_cam_typ[NOIR][GRA_ROC]	   	 /* tour supprime car pas deplace*/
     ||
     pts_hst_pro_p->defv_ech				 /* echec prof precedente */
     ||
     ts_ech[B8].i_cam!=VIDE		   	 /* case intermedaire non vide*/
     ||
     ts_ech[C8].i_cam!=VIDE
     ||
     ts_ech[D8].i_cam!=VIDE
     ||
     ctl_par_xxx	(B8)        /*  ou sous ctl adversaire */
     ||
     ctl_par_xxx	(C8)
     ||
     ctl_par_xxx	(D8)
     )
    {
      pro_pre();
      /*Grand rock impossible*/;
      return -MSG_JOU_GRD_ROC_ROC_IMP;
    }
  else					/* roc possible */
    {
      pts_hst_pro->i_typ_mvt = ROI_GRA_ROC;                /* grand rock */
      pts_hst_pro_p->defv_pat = N;                 /* pas d'echec poss*/
      dep_grd_roc_1();                            /* mvt des pices */
      jou_mvt_roi_roc(D8);
    }
  return 0;
}

int jou_pet_roc_0 	(void)
{
  if
    (
     ts_ech[E1].i_cam!=BLANC
     ||
     /* bug : pourquoi tester à -1 alors que testé  p=0 apres ?*/
     ts_hst_pro[i_pro_act-1].
     ti_roc_cam_typ[BLANC][PET_ROC]!=0
     )

    {
      pro_pre();
      /*Petit rock plus possible*/;
      return -MSG_JOU_ROI_PET_ROC_IMP;
    }
	

  /* blanc */
  if
    (
     pts_hst_pro->
     ti_roc_cam_typ[BLANC][PET_ROC] 			 /* roi ou tour deplace */
     ||
     ts_ech[H1].i_Id!=
     ti_tou_cam_typ[BLANC][PET_ROC]	   	 /* tour supprime car pas deplace*/
     ||
     pts_hst_pro_p->defv_ech				 /* echec prof precedente */
     ||
     ts_ech[F1].i_cam!=VIDE		   	 /* case intermedaire non vide*/
     ||
     ts_ech[G1].i_cam!=VIDE
     ||
     ctl_par_xxx	(F1)        /* ou sous ctl adversaire */
     ||
     ctl_par_xxx	(G1)
     )
    {
      pro_pre();
      /*Petit rock impossible*/;
      return -MSG_JOU_PET_ROC_ROC_IMP;
    }
  else					/* roc possible */
    {
      pts_hst_pro->i_typ_mvt = ROI_PET_ROC;                /*petit rock */
      pts_hst_pro_p->defv_pat = N;                 /* pas d'echec poss*/
      dep_pet_roc_0();                            /* mvt des pices */
      jou_mvt_roi_roc(F1);
    }
  return 0;
}
int jou_pet_roc_1 	(void)
{
  
  if
    (
     ts_ech[E8].i_cam!=NOIR
     ||
     ts_hst_pro[i_pro_act-1].
     ti_roc_cam_typ[NOIR][PET_ROC]!=0
     )
    {
      pro_pre();
      /*Petit rock plus possible*/;
      return -MSG_JOU_ROI_PET_ROC_IMP;
    }
	
  /* noir */
  if
    (
     pts_hst_pro->
     ti_roc_cam_typ[NOIR][PET_ROC] 		 /* roi ou tour deplace */
     ||
     ts_ech[H8].i_Id!=
     ti_tou_cam_typ[NOIR][PET_ROC]	   	 /* tour supprime car pas deplace*/
     ||
     pts_hst_pro_p->defv_ech				 /* echec prof precedente */
     ||
     ts_ech[F8].i_cam!=VIDE		   	 /* case intermedaire non vide*/
     ||
     ts_ech[G8].i_cam!=VIDE
     ||
     ctl_par_xxx	(F8)        /* ou sous ctl adversaire */
     ||
     ctl_par_xxx	(G8)
     )
    {
      pro_pre();
      /*Petit rock impossible*/;
      return -MSG_JOU_PET_ROC_ROC_IMP;
    }
  else					/* roc possible */
    {
      pts_hst_pro->i_typ_mvt = ROI_PET_ROC;       /*petit rock */
      pts_hst_pro_p->defv_pat = N;                 /* pas d'echec poss*/
      dep_pet_roc_1();                            /* mvt des pices */
      jou_mvt_roi_roc(F8);

    }
  return 0;
}
void jou_mvt_roi_roc 		(int i_pos_n_tou)
{
  /* verifie si cause echec camp adverse */
  /* par la tour */
  if ( ech_par_tou (
		    /*			(pts_hst_pro->pts_pie_pc +pts_hst_pro->i_Id_2p)->i_pos_n,      */
		    i_pos_n_tou,
		    pts_hst_pro->i_pos_n_R_c_a
		    )
       )

    set_ech_on();
  else
    set_ech_off();

  /* petit et grd rock plus possible */
  (pts_hst_pro+1)->
    ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]= 1;

  (pts_hst_pro+1)->
    ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]= 1;
		
  /* recopie valeur grd et petit rock pour cam adverse */
  cop_val_prc_ca();
  cop_val_grc_ca();
}

/* joue cavalier tour fou reine				  */
int jou_ctfr (char c_tpie_rpio)	/*rem_pio pas utilisé dans cette fct */
{
  int i_Msg;
  int i_typ_mvt_pri=0;
  int i_typ_mvt_dep=0;

  /* seulement pour éviter warning */
  if (c_tpie_rpio == 'x')
    c_tpie_rpio =' ';


  /* controle si mvt ok pour le type de piece */
  /* opti use functin pointer in piece */
  switch (pts_pie->c_typ_pie)
    {
    case 'C':
      i_Msg=ctl_mvt_cav();
      if (i_Msg!=0)
	{
	  pro_pre();
	  return i_Msg;			
	}
      else
	{
	  i_typ_mvt_dep= CAV_DEP;
	  i_typ_mvt_pri= CAV_PRI;

	}
      break;

    case 'T':
      i_Msg=ctl_mvt_tou();
      if (i_Msg!=0)
	{
	  pro_pre();
	  return i_Msg;			
	}
      else
	{
	  i_typ_mvt_dep= TFR_DEP;
	  i_typ_mvt_pri= TFR_PRI;

	}
      break;

    case 'F':
      i_Msg=ctl_mvt_fou();
      if (i_Msg!=0)
	{
	  pro_pre();
	  return i_Msg;			
	}
      else
	{
	  i_typ_mvt_dep= TFR_DEP;
	  i_typ_mvt_pri= TFR_PRI;

	}

      break;

    case 'D':
      i_Msg=ctl_mvt_rei();
      if (i_Msg!=0)
	{
	  pro_pre();
	  return i_Msg;			
	}
      else
	{
	  i_typ_mvt_dep= TFR_DEP;
	  i_typ_mvt_pri= TFR_PRI;

	}
      break;
    }


  /* determine type de mouvement: prise ou deplacement */
  if(ts_ech[pts_hst_pro->i_pos_n].i_cam == VIDE)
    {
      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= i_typ_mvt_dep;
      dep_sim();

    }
  else
    {
      /* prise simple */
      pts_hst_pro->i_typ_mvt = i_typ_mvt_pri;
      pri_sim();
    }

  /* echec pro precedente ?*/
  if (pts_hst_pro_p->defv_ech == Y)
    {
      /* verife à nouveau echec */
      /* 		par piece principale pro precedente ? */
      /* 	ou	par piece secondaire pro precedente ? */
      /* 	ou  par demasquage pro precedente ? */
      /* 	ou  par demasquage prof actuelle */

      if
	(
	 (
	  pts_hst_pro_p->i_ech_dir_pri
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_pri])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro_p->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem_p_c
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 )

	{
	  /* echec donc mvt impossible */
	  ann_cou();
	  /* Le roi se retrouve echec mvt impossible*/;
	  return -MSG_JOU_CTFR_ROI_ECH;
	}
      else	/* roi n'est plus echec  */
	{
	  /* roi n'est plus echec donc mat = N  */
	  pts_hst_pro_p->defv_mat = N;

	}

    }
  else  	/* pas d'echec prof precedente */
    {
      /* Verifie echec propre camp par demasquage  */
      if
	(
	 pts_hst_pro->i_ech_dir_dem_p_c
	 &&
	 (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	 (pts_hst_pro->i_pos_n_R_p_c,
	  pts_hst_pro->i_cam_adv)
	 )

	{
	  /* echec donc mvt impossible */
	  ann_cou();
	  /* Le roi se retrouve echec mvt impossible*/;
	  return -MSG_JOU_CTFR_ROI_ECH;
	}
      else     /* pas d'echec */
	{

	  /* roi ne se retrouve pas echec donc pat = N  */
	  pts_hst_pro_p->defv_pat = N;

	}
    }
  /* verifie si cause echec camp adverse */

  /* par mvt piece principale ou par demasquage*/
  if
    (
     (*pts_pie->pf_ech_par)
     ( pts_hst_pro->i_pos_n,pts_hst_pro->i_pos_n_R_c_a)
	
     ||
     (
      pts_hst_pro->i_ech_dir_dem
      &&
      (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem])
      (pts_hst_pro->i_pos_n_R_c_a,
       pts_hst_pro->i_cam)

      )
     )
    {
      set_ech_on();
    }
  else
    {
      set_ech_off();
    }
  /* Mise  jour roc si tour deplace */
  if 	(	pts_pie->c_typ_pie=='T')
    {
      /* si tour grand roc */
      if
	(
	 pts_hst_pro->i_Id
	 ==
	 ti_tou_cam_typ[pts_hst_pro->i_cam][GRA_ROC]
	 )
	{
	  /* preserve possibility of castling */ 
	  if( ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
	      &&
	      (pts_hst_pro)->
	      ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]== 0
	      )
	    pts_hst_pro->i_not += NOT_ROC_TOU;
	   
	  /* grd rock propre camp plus possible */
	  (pts_hst_pro+1)->
	    ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]= 1;
	  /* recopie valeur  petit rock pour cam propre */
	  cop_val_jou_prc_pc();
	
		
	}
      /* si tour petit roc */
      if
	(
	 pts_hst_pro->i_Id
	 ==
	 ti_tou_cam_typ[pts_hst_pro->i_cam][PET_ROC]
	 )
	{
	  /* preserve possibility of castling */ 
	  if( ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
	      &&
	      (pts_hst_pro)->
	      ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]== 0
	      )
	    pts_hst_pro->i_not += NOT_ROC_TOU;

	  /* pet rock propre camp plus possible */
	  (pts_hst_pro+1)->
	    ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]= 1;


	  /* recopie valeur grd  rock pour cam propre */
	  cop_val_jou_grc_pc();

	}

    }
  else
    {
			
      /* recopie valeur grd et petit rock pour cam propre */
      cop_val_jou_prc_pc();
      cop_val_jou_grc_pc();

    }
  /* recopie valeur grd et petit rock pour cam adverse */
  cop_val_jou_prc_ca();
  cop_val_jou_grc_ca();
  return 0;
}

/* joue pion blanc					*/
int jou_pio_0 	(char c_tpie_rpio)
{
  if  /* haut 1 */
    (
     pts_hst_pro->i_pos_n == pts_hst_pro->i_pos_ori_n +10
     )
    {
      if  /* deplacement normal */
	(
	 pts_hst_pro->i_pos_ori_n /10  != 7 /* ligne 7 */
	 )
	{
	  return (jou_pio_s1c());

	}
      else /* transformation du pion en une autre piece */
	{
	  return (jou_pio_pro(c_tpie_rpio));  
	}
    }
  else
    {
      if  /* haut 2 */
	(
	 pts_hst_pro->i_pos_n == pts_hst_pro->i_pos_ori_n+20
	 )
	{
	  if (pts_hst_pro->i_pos_ori_n /10  == 2) /* Ligne 2 */
	    {
	      /* joue pion saut 2 cases */
	      return (jou_pio_s2c(pts_hst_pro->i_cam));

	    }
	  else
	    {
	      /* deplacement impossible  partir de cette pos */
	      pro_pre();
	      /*Saut de 2 case possible seulement sur ligne 2*/;
	      return  -MSG_JOU_PIB_2CA_IMP;
	    }
	}
      else
	{
	  if  /* haut gauche */
	    (
	     pts_hst_pro->i_pos_n == pts_hst_pro->i_pos_ori_n + 9
	     )
	    {
	      switch(pts_hst_pro->i_pos_ori_n/10)
		{
		case 7:
		  /* joue pion  promotion + prise */
		  return (jou_pio_pro_pri(c_tpie_rpio));
	
		case 5:
		  /* joue pion  prise en passant */
		  return (jou_pio_pri_pas(pts_hst_pro->i_cam));
	
		default:
		  /* joue pion  prise */
		  return (jou_pio_pri());
		}
	    }
	  else
	    {
	      if  /* haut droite */
		(
		 pts_hst_pro->i_pos_n == pts_hst_pro->i_pos_ori_n +11
		 )
		{
		  switch(pts_hst_pro->i_pos_ori_n/10)
		    {
		    case 7:	      
		      return (jou_pio_pro_pri(c_tpie_rpio));
		    case 5:
		      return (jou_pio_pri_pas(pts_hst_pro->i_cam));
		    default:
		      return (jou_pio_pri());
		    }
		}
	      else
		{
		  /* mouvement impossible */
		  pro_pre();
		  /*Mouvement impossible*/;
		  return -MSG_JOU_PIB_MVT_IMP;
		}
	    }
	}
    }
}
/* joue pion noir 					*/
int jou_pio_1 	(char c_tpie_rpio)
{
  if  /* bas 1 */
    (
     pts_hst_pro->i_pos_n == pts_hst_pro->i_pos_ori_n - 10
     )
    {

      if  /* deplacement normal */
	(
	 pts_hst_pro->i_pos_ori_n /10 != 2
	 )
	{

	  return (jou_pio_s1c());
	}
      else /* transformation du pion en une autre piece */
	{
	  return (jou_pio_pro(c_tpie_rpio));
	}
    }
  else
    {
      if  /* bas 2 */
	(
	 pts_hst_pro->i_pos_n == pts_hst_pro->i_pos_ori_n-20
	 )
	{
	  if (pts_hst_pro->i_pos_ori_n /10 == 7)
	    {
	      return (jou_pio_s2c(pts_hst_pro->i_cam));
	    }
	  else
	    {
	      /* deplacement impossible  partir de cette pos */
	      pro_pre();
	      /*Saut de 2 case possible seulement sur ligne 2*/;
	      return -MSG_JOU_PIN_2CA_IMP;
	    }

	}
      else
	{
	  if  /* bas gauche */
	    (
	     pts_hst_pro->i_pos_n == pts_hst_pro->i_pos_ori_n - 11
	     )
	    {
	      switch(pts_hst_pro->i_pos_ori_n/10)
		{
		case 2:
		  /* prise + promotion */
		  return (jou_pio_pro_pri(c_tpie_rpio));
				  
		case 4:
		  /* prise en passant  ou prise simple */
		  return (jou_pio_pri_pas(pts_hst_pro->i_cam));
	
		default:
		  return (jou_pio_pri());

		}
	    }
	  else
	    {
	      if  /* bas  droite */
		(
		 pts_hst_pro->i_pos_n == pts_hst_pro->i_pos_ori_n -9
		 )
		{
		  switch(pts_hst_pro->i_pos_ori_n/10)
		    {
		    case 2:
		      /* promotion + prise */
		      return (jou_pio_pro_pri(c_tpie_rpio));
		    case 4:
		      /* prise en passant ou prise normale */
		      return (jou_pio_pri_pas(pts_hst_pro->i_cam));
		    default:
		      /* prise normale */
		      return (jou_pio_pri());
		    }
		}
	      else
		{
		  /* mouvement impossible */
		  pro_pre();
		  /* Mouvement impossible*/;
		  return -MSG_JOU_PIN_MVT_IMP;
		}
	    }
	}
    }	
}

int jou_pio_s1c 	(void)
{
  /* joue pion saut 1 case */
  /* case d'arrive vide */
  if
    (
     ts_ech[pts_hst_pro->i_pos_n].i_cam
     ==
     VIDE
     )
    {
      pts_hst_pro->i_typ_mvt 	= PIO_1C;
      dep_sim();
    }
  else /* case d'arrive occupe */
    {
      pro_pre();
      /*La case d'arrive doit tre libre*/;
      return -MSG_JOU_PIB_ARR_OCC;
    }
  return (jou_mvt_pio());

}
int jou_pio_pro 	(char c_tpie_rpio)
{
  /* joue pion promotion */
  if   /* case d'arrivee libre */
    (
     ts_ech[pts_hst_pro->i_pos_n].i_cam
     ==
     VIDE
     )
    {
      /* Verifie type de  piece  sinon demande interactive */
      /* et traduction lib piece vers type piece */
      if(pro_pio_ver_typ_pie(c_tpie_rpio)<0)
	c_tpie_rpio= pro_pio_cho_wra();
      switch(c_tpie_rpio)
	{
	  /* transformation en cavalier */
	case 'C'  :
	  pts_hst_pro->i_typ_mvt 	= PIO_PRO_CAV;
	  dep_sim();
	  set_pie_cav_blanc();
	  return (jou_mvt_pio());

	  /* transformation en reine */
	case 'D' :
	  pts_hst_pro->i_typ_mvt 	= PIO_PRO_REI;
	  dep_sim();
	  set_pie_rei_blanc();
	  return (jou_mvt_pio());
	default :
	  return -MSG_JOU_PIO_PIE_PRO_INV;
	}
    }
  else
    {
      /* mvt impossible  */
      pro_pre();
      /*La case d'arrive doit tre libre*/;
      return  -MSG_JOU_PIB_ARR_OCC;
    }	 
}
int jou_pio_s2c 	(int i_cam)
{	
  /* joue pion saut 2 cases */
  int i_inc;
  if (i_cam == BLANC)
    i_inc= -10;
  else
    i_inc = 10;
  if
    (
     ts_ech[pts_hst_pro->i_pos_n].i_cam
     == VIDE
     &&
     ts_ech[pts_hst_pro->i_pos_n + i_inc]
     .i_cam == VIDE
     )
    {
      /* deplacement simple */
      pts_hst_pro->i_typ_mvt 	= PIO_2C;
      dep_sim();
    }
  else
    {
      /* mvt impossible  */
      pro_pre();
      /*Les cases intermediares et d'arrivee doivent etre libre*/;
      return  -MSG_JOU_PIB_INT_OCC;
    }
  return (jou_mvt_pio());
}
int jou_pio_pro_pri 	(char c_tpie_rpio)
{
  /* joue pion  promotion + prise */
  /* le cas de prise piece propre camp est traité dans fct appelante */
  switch(ts_ech[pts_hst_pro->i_pos_n].i_cam)
    {
    case VIDE:
      pro_pre();
      /*Pas de piece a prendre*/;
      return  -MSG_JOU_PIB_PAS_PIE_PRI;
    default:
      /* Verifie type de  piece  sinon demande interactive */
      /* et traduction lib piece vers type piece */
      if(pro_pio_ver_typ_pie(c_tpie_rpio)<0)
	c_tpie_rpio= pro_pio_cho_wra();

      switch(c_tpie_rpio)
	{
	  /* transformation en cavalier */
	case 'C' :
	  pts_hst_pro->i_typ_mvt 	= PIO_PRO_CAV_PRI;
	  pri_sim();
	  set_pie_cav_blanc();
	  return(jou_mvt_pio());
	  /* transformation en reine */
	case 'D' :
	  pts_hst_pro->i_typ_mvt 	= PIO_PRO_REI_PRI;
	  pri_sim();
	  set_pie_rei_blanc();
	  return(jou_mvt_pio());
	default :
	  return -MSG_JOU_PIO_PIE_PRO_INV;
	}
    }
}

int jou_pio_pri_pas 	(int i_cam)
{
  int i_inc;
  /* por calcul position relative du pion à prendre */ 
  /* le cas de prise piece propre camp est traité dans fct appelante */

  if(i_cam == BLANC)
    i_inc= +10;
  else
    i_inc= -10;

  /* joue pion  prise en passant */
  switch(ts_ech[pts_hst_pro->i_pos_n].i_cam)
    {

    case VIDE:

      if
	(
	 (tpts_pie[NOIR]+pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
	 &&
	 /* test position d'arrive du pion  prendre   */
	 pts_hst_pro_p->i_pos_n == pts_hst_pro->i_pos_n - i_inc
	 &&
	 /*  test position de dpart du pion  prendre */
	 pts_hst_pro_p->i_pos_ori_n == pts_hst_pro->i_pos_n + i_inc

	 )
	{
	  /* prise en passant */
	  pts_hst_pro->i_typ_mvt 	= PIO_PRI_PAS;
	  pri_pas();
	  return jou_mvt_pio();
	}
      else
	{
	  pro_pre();
	  /*Pas de piece a prendre*/;
	  return -MSG_JOU_PIB_PAS_PIE_PRI;
	}
    default:
      pts_hst_pro->i_typ_mvt 	= PIO_PRI;
      pri_sim();
      return (jou_mvt_pio());
    }	
}
int jou_pio_pri 	(void)
{
  /* joue pion  prise */
  /* le cas de prise piece propre camp est traité dans fct appelante */
  switch(ts_ech[pts_hst_pro->i_pos_n].i_cam)
    {
    case VIDE:
      pro_pre();
      /*Pas de piece a prendre*/;
      return -MSG_JOU_PIB_PAS_PIE_PRI;
    default :
      pts_hst_pro->i_typ_mvt 	= PIO_PRI;
      pri_sim();
      return jou_mvt_pio();

    }	
}


/* joue pion */
int jou_mvt_pio 	(void)
{

  /* echec pro precedente ?*/
  if (pts_hst_pro_p->defv_ech == Y)
    {
      /* verife à nouveau echec */
      /* 		par pièce principale pro precedente ? */
      /* 	ou	par pièce secondaire pro precedente ? */
      /* 	ou  par demasquage pro precedente ? */
      /* 	ou  par demasquage prof actuelle */

      if
	(
	 (
	  pts_hst_pro_p->i_ech_dir_pri
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_pri])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro_p->i_ech_dir_dem
	  &&
	  (*tpf_cas_ctl[pts_hst_pro_p->i_ech_dir_dem])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 ||
	 (
	  pts_hst_pro->i_ech_dir_dem_p_c
	  &&
	  (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	  (pts_hst_pro->i_pos_n_R_p_c,
	   pts_hst_pro->i_cam_adv)

	  )
	 )

	{
	  /* echec donc mvt impossible */
	  pts_hst_pro->i_not = NOT_MIN;
	  ann_cou();
	  /*Le roi se retrouve echec: mouvement impossible*/;
	  return -MSG_JOU_PIO_ROI_ECH;
	}
      else	/* roi n'est plus echec  */
	{
	  /* roi n'est plus echec donc mat = N  */
	  pts_hst_pro_p->defv_mat = N;

	}

    }
  else  	/* pas d'echec prof precedente */
    {

      /* Verifie echec propre camp par demasquage  */
      if
	(
	 pts_hst_pro->i_ech_dir_dem_p_c
	 &&
	 (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem_p_c])
	 (pts_hst_pro->i_pos_n_R_p_c,
	  pts_hst_pro->i_cam_adv)

	 )

	{
	  /* echec donc mvt impossible */
	  pts_hst_pro->i_not = NOT_MIN;
	  ann_cou();
	  /*Le roi se retrouve echec: mouvement impossible*/;
	  return -MSG_JOU_PIO_ROI_ECH;
	}
      else     /* pas d'echec */
	{

	  /* roi ne se retrouve pas echec donc pat = N  */
	  pts_hst_pro_p->defv_pat = N;

	}
    }

  /* verifie si cause echec camp adverse */
  /* par mvt pièce principale ou par demasquage*/
  if
    (
     (*pts_pie->pf_ech_par)
     ( pts_hst_pro->i_pos_n,pts_hst_pro->i_pos_n_R_c_a)
     ||
     (
      /* recupere position de la piece prise en passant */
      /* puis vérifie si echec en calculant la direction */
      /* de la piece prise vers le roi */

      (*tpf_cas_ctl 
       [
	ech_cal_dir_dem_2 
	(
	 pts_hst_pro->i_cam_adv,
	 (pts_hst_pro->pts_pie_ca + pts_hst_pro->i_Id_2p)->i_pos_n
	 )
	]
       )
      (pts_hst_pro->i_pos_n_R_c_a,
       pts_hst_pro->i_cam)
      )    
	
	
     ||

     (
      pts_hst_pro->i_ech_dir_dem
      &&
      (*tpf_cas_ctl[pts_hst_pro->i_ech_dir_dem])
      (pts_hst_pro->i_pos_n_R_c_a,
       pts_hst_pro->i_cam)

      )
     )
    {
      set_ech_on();
    }
  else
    {
      set_ech_off();
    }


		
  /* recopie valeur grd et petit rock pour cam propre */
  cop_val_jou_prc_pc();
  cop_val_jou_grc_pc();

  /* recopie valeur grd et petit rock pour cam adverse */
  cop_val_jou_prc_ca();
  cop_val_jou_grc_ca();
		
  return 0;

}
/* Copie val petit/grand rock  pour propre camp */
void cop_val_jou_prc_pc (void)
{
  (pts_hst_pro+1)->
    ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]=
    pts_hst_pro->
    ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC];

}
void cop_val_jou_grc_pc (void)
{
  (pts_hst_pro+1)->
    ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]=
    pts_hst_pro->
    ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC] ;

}

/* Copie val petit/grand rock  camp adverse */
void cop_val_jou_prc_ca (void)
{
  (pts_hst_pro+1)->
    ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC]=
    pts_hst_pro->
    ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC];

}
void cop_val_jou_grc_ca (void)
{
  (pts_hst_pro+1)->
    ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC]=
    pts_hst_pro->
    ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC] ;

}


/* annule coup				  */
int ann_cou_int (void)
{
  if (i_pro_act <1)
    {
      /* Pas de coup precedent */
      return -MSG_PAS_COU_PRE;
    }
  else
    {
      defv_aff_not_pos = N;
      ann_cou();
      i_end_gam=0;
      //      sav_dsk("ec.wrk");
      return 0;
    }
	
}
/* annule coup				  */
void ann_cou (void)
{
  /* restore pièce principale */
  if(tpf_res_pie[pts_hst_pro->i_typ_mvt])
    (*tpf_res_pie[pts_hst_pro->i_typ_mvt]) 	();
		
  /* profondeur precedente */
  pro_pre();

}

/* profondeur precedente	  */
void pro_pre (void)
{

  i_pro_act--;
  /* initialisation du  pionteurs sur hst */
  pts_hst_pro 	= &ts_hst_pro[i_pro_act];
  pts_hst_pro_p 	= &ts_hst_pro[i_pro_act-1];

  /* initialisation du  pionteurs piece actuelle  */
  pts_pie =
    pts_hst_pro->pts_pie_pc +pts_hst_pro->i_Id;
}


/*Ctl mouvement roi  autre que rock */
int ctl_mvt_roi(void)
{
  switch(pts_hst_pro->i_pos_n -	pts_hst_pro->i_pos_ori_n)
    {
    case -10 :
    case -11 :
    case -1 :
    case 9 :
    case 10 :
    case 11 :
    case 1 :
    case -9 :
      return 0;
    default :
      /*Le roi ne peut atteindre cette case */;
    return -MSG_MVT_ROI_MVT_IMP;
    }
}

int ctl_mvt_cav()
{
  if(ti_ech_dir_cav[ pts_hst_pro->i_pos_ori_n ][ pts_hst_pro->i_pos_n])
    return 0;
  else	
    return -MSG_MVT_CAV_MVT_IMP;			
}
int ctl_mvt_tou()
{
  int no;           /* coordonnée origine      */
  int na;           /* coordonnée arrivée      */
  int n;
  int inc;

  no = pts_hst_pro->i_pos_ori_n;
  na = pts_hst_pro->i_pos_n;

  if ( ti_ech_dir_tou[no][na])
    {
      inc=ti_ech_dir_inc[no][na];
 
      for (n=na+inc; n!=no;n+=inc)
	{ 
	
	  if (ts_ech[n].i_cam >=0) 
	    /*La tour ne peut sauter au dessus d'une piece*/
	    return  -MSG_MVT_TOU_SAU_PIE;
	}
      return 0; 
    }
  else
    {
      /*La tour ne peut atteindre cette case*/
      return -MSG_MVT_TOU_MVT_IMP;
    }

}	
int ctl_mvt_fou()
{
  int no;           /* coordonnée origine      */
  int na;           /* coordonnée arrivée      */
  int n;	    /* Compteur pour balayage  */
  int inc;

 
  no = pts_hst_pro->i_pos_ori_n;
  na = pts_hst_pro->i_pos_n;
  if ( ti_ech_dir_fou[no][na])
    {
      inc=ti_ech_dir_inc[no][na];
      for (n=na+inc; n!=no;n+=inc)
	{ 
	  if (ts_ech[n].i_cam >=0)
	    /* Le fou ne peut sauter une pièce */
	    return -MSG_MVT_FOU_SAU_PIE;
	 
	}
      return 0; 
    }
  else
    {
      /*La fou ne peut atteindre cette case*/
      return -MSG_MVT_FOU_MVT_IMP;
    }

}
int ctl_mvt_rei()
{	
			
  int no;           /* coordonnée origine      */
  int na;           /* coordonnée arrivée      */
  int n;
  int inc;

 
  no = pts_hst_pro->i_pos_ori_n;
  na = pts_hst_pro->i_pos_n;

 
 
  if ( ti_ech_dir_rei[no][na])
    {
      inc=ti_ech_dir_inc[no][na];
      for (n=na+inc; n!=no ;n+=inc)
	{ 
	  if (ts_ech[n].i_cam >=0) 
	    /*La reine ne peut sauter au dessus d'une piece*/
	    return  -MSG_MVT_REI_SAU_PIE;	
	}
      return 0; 
    }
  else
    {
      /*La reine ne peut atteindre cette case*/
      return  -MSG_MVT_REI_MVT_IMP ;
    }

}

/* Chargement variable avec message */
int cha_mes (int i_mes_num,char *tc_lib_mes)
{
  int i_lon_tot_par=0;
  int x;

  /* st_par_mes is a global must be loaded if sub string are needed  */ 

  for (x= 0; x<= (st_par_mes.i_nbr_par-1); x++)
    i_lon_tot_par += strlen(st_par_mes.tc_par_mes[x]);
  
  /* Didn't find a methode to know exactly how much char will be used */
  if( (strlen( _(tptc_msg[abs(i_mes_num)]) ) + i_lon_tot_par) > LEN_MES-10)
    return -MSG_CHA_MES_LON_MSG;
  /* bug: pas testé en retour de fonction */
 
  switch (st_par_mes.i_nbr_par)
    {
    case 0:
      strcpy (tc_lib_mes , _(tptc_msg[abs(i_mes_num)]));
 
    case 1:
      sprintf(tc_lib_mes,_(tptc_msg[abs(i_mes_num)]), 
	      st_par_mes.tc_par_mes[0]);
      break;
    case 2:
      sprintf(tc_lib_mes, _(tptc_msg[abs(i_mes_num)]),
	      st_par_mes.tc_par_mes[0],
	      st_par_mes.tc_par_mes[1]);

      break;
    case 3:
      sprintf(tc_lib_mes, _(tptc_msg[abs(i_mes_num)]),
	      st_par_mes.tc_par_mes[0],
	      st_par_mes.tc_par_mes[1],
	      st_par_mes.tc_par_mes[2]);
      break;
    case 4:
      sprintf(tc_lib_mes, _(tptc_msg[abs(i_mes_num)]),
	      st_par_mes.tc_par_mes[0],
	      st_par_mes.tc_par_mes[1],
	      st_par_mes.tc_par_mes[2],
	      st_par_mes.tc_par_mes[3]);
      break;
    case 5:
      sprintf(tc_lib_mes, _(tptc_msg[abs(i_mes_num)]),
	      st_par_mes.tc_par_mes[0],
	      st_par_mes.tc_par_mes[1],
	      st_par_mes.tc_par_mes[2],
	      st_par_mes.tc_par_mes[3],
	      st_par_mes.tc_par_mes[4]);
      break;
    case 6:
      sprintf(tc_lib_mes, _(tptc_msg[abs(i_mes_num)]),
	      st_par_mes.tc_par_mes[0],
	      st_par_mes.tc_par_mes[1],
	      st_par_mes.tc_par_mes[2],
	      st_par_mes.tc_par_mes[3],
	      st_par_mes.tc_par_mes[4],
	      st_par_mes.tc_par_mes[5]);
      break;
    case 7:
      sprintf(tc_lib_mes, _(tptc_msg[abs(i_mes_num)]),
	      st_par_mes.tc_par_mes[0],
	      st_par_mes.tc_par_mes[1],
	      st_par_mes.tc_par_mes[2],
	      st_par_mes.tc_par_mes[3],
	      st_par_mes.tc_par_mes[4],
	      st_par_mes.tc_par_mes[5],
	      st_par_mes.tc_par_mes[6]);
      break;
    case 8:
      sprintf(tc_lib_mes, _(tptc_msg[abs(i_mes_num)]),
	      st_par_mes.tc_par_mes[0],
	      st_par_mes.tc_par_mes[1],
	      st_par_mes.tc_par_mes[2],
	      st_par_mes.tc_par_mes[3],
	      st_par_mes.tc_par_mes[4],
	      st_par_mes.tc_par_mes[5],
	      st_par_mes.tc_par_mes[6],
	      st_par_mes.tc_par_mes[7]);
      break;
    case 9:
      sprintf(tc_lib_mes, _(tptc_msg[abs(i_mes_num)]),
	      st_par_mes.tc_par_mes[0],
	      st_par_mes.tc_par_mes[1],
	      st_par_mes.tc_par_mes[2],
	      st_par_mes.tc_par_mes[3],
	      st_par_mes.tc_par_mes[4],
	      st_par_mes.tc_par_mes[5],
	      st_par_mes.tc_par_mes[6],
	      st_par_mes.tc_par_mes[7],
	      st_par_mes.tc_par_mes[8]);
      break;

    default:
      break;
    }

  /* remise a zero nbr de parametres */
  st_par_mes.i_nbr_par=0;  
  return 0;
}


/* Choix du niveau increment  */
int cho_niv (int i_niv, int i_inc)
{
  if(i_niv>PRO_SIM_SUP_MAX || i_niv<3)
    {
      /* Level must be  3 to:%s */
      st_par_mes.i_nbr_par=2;
      snprintf(st_par_mes.tc_par_mes[0],LON_MAX_PAR_MES,"%i",3);
      snprintf(st_par_mes.tc_par_mes[1],LON_MAX_PAR_MES,"%i",PRO_SIM_SUP_MAX);
 
      return -MSG_CHO_NIV_INV;
    }
  else
    {
      if(i_inc>PRO_SIM_INF_MAX-PRO_SIM_SUP_MAX || i_inc<0)
	{
	  /* Error: Increment must be 0 to %i*/
	  st_par_mes.i_nbr_par=2;
	  snprintf(st_par_mes.tc_par_mes[0],LON_MAX_PAR_MES,"%i",0);
	  snprintf(st_par_mes.tc_par_mes[1],LON_MAX_PAR_MES,"%i",PRO_SIM_INF_MAX - PRO_SIM_SUP_MAX);

	  return -MSG_CHO_INC_INV;
	}
      else
	{
	  if(i_niv + i_inc > PRO_SIM_INF_MAX)
	    {
	      /*Level + increment must be bellow %s */
	      st_par_mes.i_nbr_par=1; 
	      snprintf(st_par_mes.tc_par_mes[0],LON_MAX_PAR_MES,"%i",PRO_SIM_INF_MAX);
     
	      return -MSG_CHO_NIV_INC_INV;				
	    }
	  else /* Tout est bon */
	    {
	      i_pro_sim_niv = i_niv;
	      i_pro_sim_inc = i_inc;
	      return 0;
	    }
	}
    }		
}


/* verifie  si affichage note possible */
int ver_aff_not_pos(void)
{
  if(defv_aff_not_pos == Y)
    {
      return 0;
    }
  else
    {
      /* Affichage de la note plus possible */
      return -MSG_VER_AFF_NOT_IMP;
    }
}

/* verifie existance mvt ini */
int ver_exi_mvt_ini(int i_mvt_ini)
{
  if(i_mvt_ini <0 || i_mvt_ini >= i_not_cpt_mvt_ini)
   
    /* Mouvement inexistant */
    return -MSG_EXI_MVT_INI_NON;

  else 

    return 0;			
}
/* verifie validite choix  libelle piece promotion du pion */
int pro_pio_ver_lib_pie(char c_lib_pie)
{ 	
  c_lib_pie=toupper(c_lib_pie);
  /* utilise le libelle de la piece blanche car en majuscule!..*/
  if (
      c_lib_pie!= *(_("LIB_PIE_Q")+8)  &&  
      c_lib_pie!= *(_("LIB_PIE_N")+8)   )

    {
      st_par_mes.i_nbr_par=2;
      strncpy(st_par_mes.tc_par_mes[0],_(tptc_msg[ MSG_TYP_LIB_CAV ]),LON_MAX_PAR_MES );
      strncpy(st_par_mes.tc_par_mes[1],_(tptc_msg[ MSG_TYP_LIB_REI ]),LON_MAX_PAR_MES );
    
      return -MSG_VER_CHO_PRO_PIO ;
    }
  else
    {
      /* retourne le type de piece a la place du libelle dependant de la langue */
      return 0;
    }

}
/* verifie validite type  piece pour promotion pion */
int pro_pio_ver_typ_pie(char c_typ_pie)
{ 	
  c_typ_pie=toupper(c_typ_pie);
  /* */
  if (
      c_typ_pie!= 'C'   &&
      c_typ_pie!= 'D'  )

    {
      st_par_mes.i_nbr_par=2;
      strncpy(st_par_mes.tc_par_mes[0],_(tptc_msg[ MSG_TYP_LIB_CAV ]),LON_MAX_PAR_MES );
      strncpy(st_par_mes.tc_par_mes[1],_(tptc_msg[ MSG_TYP_LIB_REI ]),LON_MAX_PAR_MES );
    
      return -MSG_VER_CHO_PRO_PIO ;
    }
  else
    {
      return 0;
    }

}
/* traduit libelle piece en type piece */
char pro_pio_tra_lpie_tpie(char c_lib_pie)
{
  c_lib_pie=toupper(c_lib_pie);

  if (c_lib_pie ==  *(_("LIB_PIE_N")+8) )
    return 'C';
  if (c_lib_pie ==  *(_("LIB_PIE_Q")+8) )
    return 'D';
  if (c_lib_pie ==  *(_("LIB_PIE_R")+8) )
    return 'T';
  if (c_lib_pie ==  *(_("LIB_PIE_B")+8) )
    return 'F';

  return ' ';

}
/* traduit type piece en libelle piece  */
char pro_pio_tra_tpie_lpie(char c_typ_pie)
{
  c_typ_pie=toupper(c_typ_pie);

  switch (c_typ_pie)
    {
    case 'C' :
      return *(_("LIB_PIE_N")+8) ;
    case 'D' :
      return  *(_("LIB_PIE_Q")+8) ;
    case 'T' :
      return  *(_("LIB_PIE_Q")+8) ;
    case 'F' :
      return *(_("LIB_PIE_R")+8) ;
    default :
      return ' ';

    }
}
/* traduit type mvt  en type piece   */
char pro_pio_tra_tmvt_lpie(int i_typ_mvt)
{
  switch (i_typ_mvt)
    {
    case PIO_PRO_REI:
    case PIO_PRO_REI_PRI:
      return *(_("LIB_PIE_Q")+8) ;

    case PIO_PRO_TOU:
    case PIO_PRO_TOU_PRI:
      return *(_("LIB_PIE_R")+8) ;

    case PIO_PRO_FOU:
    case PIO_PRO_FOU_PRI:
      return *(_("LIB_PIE_B")+8) ;

    case PIO_PRO_CAV:
    case PIO_PRO_CAV_PRI:
      return *(_("LIB_PIE_N")+8) ;

    default:
      return ' ';
    }
}
/* traduit type mvt  en type piece   */
char pro_pio_tra_tmvt_tpie(int i_typ_mvt)
{
  switch (i_typ_mvt)
    {

    case PIO_PRO_REI:
    case PIO_PRO_REI_PRI:
      return 'D';

    case PIO_PRO_TOU:
    case PIO_PRO_TOU_PRI:
      return 'T';

    case PIO_PRO_FOU:
    case PIO_PRO_FOU_PRI:
      return 'F';

    case PIO_PRO_CAV:
    case PIO_PRO_CAV_PRI:
      return 'C';

    default:
      return ' ';
    }
}
int is_mov(char *tc_com)
{
  if (
      isalpha(tc_com[0])
      &&
      isdigit(tc_com[1])
      &&
      isalpha(tc_com[2])
      &&
      isdigit(tc_com[3])

      
      )
    {
      return 1;
    }
  else
    {
    return 0;
    }
}
int get_turn(void)
{
  return ts_hst_pro[i_pro_act+1].i_cam;
}
/* quit pgm */
void quit_pgm(void)
{
  extern int sav_end_gam(void);
  extern int sav_gam(void);
  if(i_end_gam)
      sav_end_gam();
  else
      sav_gam();
  exit(0);
}
/* resigne game */
void resign(void)
{
  i_end_gam=1;
}
