/*   
    
Chess-Ec     Copyright (C)   2001-2008 Marc Dechico

ec_jou.c : 	function used to let the user (check validity of the move) 
or to let the computer  move pieces after evaluating the best move 
	       
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

To contact the author:	
Marc Dechico
Kerfring
29390 SCAER France
tel: 06 37 98 22 54
Mail: ec@chess-ec.org  
    
*/

#include "ec_global.h"

/**********************************************************/
/* external  datas */
/**********************************************************/

/* 1 si prise piece */
extern  const int ti_typ_mvt_pri[NBR_TYP_MVT];

/* tableau pointant sur pièce camp 0 ou 1 */
/* poste 0 camp 0, 1 camp 1 */
extern struct st_pie *tpts_pie[2];		
/* tableau echiquier accès par l'emplacement  */
extern struct st_ech ts_ech[100];
/* tableau historique des coups */
extern  struct st_hst_pro ts_hst_pro[PRO_HST];

/* Tableau donnant l'ID de la tour suivant le roc et le cam */
 /* Camp: NOIR/BLANC Typ GRA_ROC/PET_ROC */
extern int ti_tou_cam_typ[2][2];       

/*  pour detection echec ec_ctl.c */
/*extern const int ti_ech_dir_rei[100][100];*/
extern  def_ti_ech_dir_rei  ti_ech_dir_rei;
extern  def_ti_ech_dir_fou  ti_ech_dir_fou;
extern  def_ti_ech_dir_tou  ti_ech_dir_tou;
extern  def_ti_ech_dir_cav  ti_ech_dir_cav;
extern  def_ti_ech_dir_roi  ti_ech_dir_roi;
extern  def_ti_ech_dir_rei  ti_ech_dir_pio_noi;
extern  def_ti_ech_dir_rei  ti_ech_dir_pio_bla;
extern  def_ti_ech_dir_rei  ti_ech_dir_inc;
/* tableau  controle à nouveau echec demasquage*/
extern def_tpf_cas_ctl  tpf_cas_ctl;	

/* Table des messages utilisateur */
extern def_tptc_msg tptc_msg;

/* strucuture parametre messages */
static struct st_par st_par_mes;

/* Memorisation de position des pieces detecter les cas de partie nulle */
  /* =1 si affichage note possible */
extern defv_bool defv_aff_not_pos;              
/* = 1 si affichage calcul en cour */      
extern defv_bool defv_aff_cal_cou;		
/* profondeur actuelle	*/
extern int i_pro_act;                          
/* niveau de simulation */
extern int i_pro_sim_niv;		
/* nivde simu pour increment*/	
extern int i_pro_sim_inc;		
/* note: compteur mvt initial 		*/
extern int i_not_cpt_mvt_ini;			
/* ptr sur tableau structure historique  */
extern struct st_hst_pro	*pts_hst_pro; 	
/* ptr sur tableau structure historique  */
extern struct st_hst_pro	*pts_hst_pro_p; 
/* ptr sur tbl structure pièce principale*/
extern struct st_pie  		*pts_pie;      	

/**********************************************************/
/* external  function*/
/**********************************************************/

extern void ini_pgm 	(void);
extern char pro_pio_cho_wra (void);
/* retourne meilleur mouvement */
extern int  simul(int i_pro_sim_niv_wrk,	
		  int i_pro_sim_inc_wrk,
		  defv_bool defv_bool__hash,
		  defv_bool defv_bool_ini_mvt_ini,
		  defv_bool defv_bool_ini_rap_for,
		  def_pf_not_cal pf_not_cal,
		  int i_cam_ene  );
/* simulation pour controle mat/pat */
extern int  simul_ctl(void);			
/* simulation pour evaluation meilleur mvt */
extern int  simul_eva(int i_pro_sim_niv_wrk,	
		      int i_pro_sim_inc_wrk	);
/* initialisation hst avec pos roi camp propre et adverse*/
extern void hst_pos_roi (void);                 
/* deplacement simple*/
extern void dep_sim(void);		
/* prise simple */
extern void pri_sim(void);			
extern void set_ech_on(void);
extern void set_ech_off(void);
 /* petit rock blanc */
extern void dep_pet_roc_0(void);              
 /* petit rock noir */
extern void dep_pet_roc_1(void);              
 /* grand rock blanc */
extern void dep_grd_roc_0(void);              
/* grand rock noir */
extern void dep_grd_roc_1(void);              
 /* camp adverse */  
extern void cop_val_grc_ca (void);            
extern void cop_val_prc_ca (void);
extern void set_pie_cav_blanc(void);
extern void set_pie_rei_blanc(void);
	/* prise ne passant */
extern void pri_pas(void);		
extern void ech_cal_dir_dem_ca  (void);
extern void ech_cal_dir_dem_pc  (void);
extern int ctl_par_xxx(int nn);
extern int ech_par_tou     (int n, int nr);
extern int  ech_cal_dir_dem_2  (int i_cam_roi,int i_pos_n);
/* controle si trait se reproduit */	
extern int  ctl_rep_pos (int i_pro);		
/* sauvegarde du trait */		
extern  void sav_pos (int i_pro);		
  /* simul et joue  */
extern int  sim_jou         (void);                           




extern const def_tpf_res_pie tpf_res_pie[];

/*****************************************************************************/
/* local function */
/*****************************************************************************/


/* joue interactif + reponse ordinateur  */
int jou_int_jou	 (char *ptc_dep,		
		  char *ptc_arr);

/* joue interactif + controle echec  */
int jou_int_ctl	 (char *ptc_dep,		
		  char *ptc_arr);

/* joue interactif */
int jou_int 	 (char *ptc_dep,		
		  char *ptc_arr);

/* joue avec coordonnes reelles */	  
 int jou		(int i_pos_dep_n,  		
		 int i_pos_arr_n,
		 char c_rem_pio	);
 /* initialisation profondeur suivante */
static void jou_pro_sui	(int i_pos_dep_n,      
			 int i_pos_arr_n);
/* joue roi*/				 
int jou_roi 		(char c_rem_pio);
/* joue roi grd rock blanc*/
static int jou_grd_roc_0 	(void);	 	
/* joue roi grd rock noir */
static int jou_grd_roc_1 	(void);	 	
/* joue roi petit rock blanc */	
static int jou_pet_roc_0 	(void);	 	
/* joue roi petit rock noir */
static int jou_pet_roc_1 	(void);	 	
/* joue roi fct commune rock	*/
static void jou_mvt_roi_roc	(int i_pos_n_tou);	
/* joue cavalier tour fou reine */
int jou_ctfr		(char c_rem_pio); 
/* joue pion blanc */
int jou_pio_0 		(char c_rem_pio); 
/* joue pion noir  */
int jou_pio_1 		(char c_rem_pio); 
/* joue pion saut 1 case */
static int jou_pio_s1c 	(void);	 	
/* joue pion promotion */
static int jou_pio_pro 	(char c_tpie_rpio);
/* joue pion saut 2 cases */
static int jou_pio_s2c 	(int i_cam); 	
/* joue pion  promotion + prise */
static int jou_pio_pro_pri 	(char c_tpie_rpio);	
/* joue pion  prise en passant */
/* joue pion  prise */

static int jou_pio_pri_pas 	(int i_cam);static int jou_pio_pri 	(void); 	

/* joue pion fct commune rock */
static int jou_mvt_pio		(void); 		
/* Copie val grand/petit rock */
/* pour propre camp */
static void cop_val_jou_grc_pc (void);             	
static void cop_val_jou_prc_pc (void);
/* camp adverse */
static void cop_val_jou_grc_ca (void);             	
static void cop_val_jou_prc_ca (void);

 /* annule coup interactif */
int  ann_cou_int (void);	        
/* annule coup */       
void ann_cou 	 (void);		
/* profondeur precedente */
static void pro_pre 	 (void);		
/* pour transformer A1 en x=2,y=2 */
static int  tra_col (char c_col);      	
static int  tra_lig (char c_lig);
 /* controle mouvement */
static int ctl_mvt_cav(void);
static int ctl_mvt_roi(void);                             
static int ctl_mvt_tou(void);
static int ctl_mvt_fou(void);
static int ctl_mvt_rei(void);

/* Chargement variable avec message */
int cha_mes (int i_mes_num,char *tc_lib_mes);

/* verifie  si affichage note possible */
int ver_aff_not_pos(void);

/* verifie existance mvt ini */
int ver_exi_mvt_ini(int i_mvt_ini);


/* verifie validite du libelle piece promotion du pion */
 int  pro_pio_ver_lib_pie(char c_lib_pie);

/* verifie validite du type piece promotion du pion */
 int  pro_pio_ver_typ_pie(char c_typ_pie);

/* traduit libelle piece en type piece */
 char pro_pio_tra_lpie_tpie(char c_lib_pie);

/* traduit type mvt en type  piece*/
 char pro_pio_tra_tmvt_tpie (int i_typ_mvt);

/* traduit type mvt en type  piece*/
char pro_pio_tra_tmvt_lpie (int i_typ_mvt);

/* traduit type piece en libelle piece*/
char pro_pio_tra_tpie_lpie (char  i_typ_pie);

/* Choix profondeur et incrément de simulation */
 int cho_niv (int i_niv, int i_inc);

/* Is the commande alike a move  ("E2E4") */
int is_mov(char *tc_com);

/*Get the side that has to  play */
int get_turn(void);


/* quit pgm */
void quit_pgm(void);
/* resign game */
void resign (void);

/*****************************************************************************/
/* local datas */
/*****************************************************************************/
int i_end_gam;
