/*   
     
Chess-Ec    Copyright (C)   2001-2008 Marc Dechico


      ec_prt.h : printing data on screen (chess board and collected data) 
  
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 To contact the author:	Marc Dechico
 Kerfring
 29390 SCAER France
 tel: 06 37 98 22 54
 Mail: ec@chess-ec.org  
    
*/


#include "ec_global.h"

/* Pagination pour toutes les fonction d'affichage necessitant plus d'1 page */
/* bug find a way to declare it static without a warning messge */
struct st_aff tst_aff[st_aff_dim];
/************************************************************************/ 
/* external datas */
/************************************************************************/
/* tableau pointant sur pièce camp 0 ou 1 */
/* poste 0 camp 0, 1 camp 1 */

extern struct st_pie *tpts_pie[2];	
 /* tableau echiquier accès par l'emplacement  */
extern struct st_ech ts_ech[100];              
 /* tableau historique des coups */
extern  struct st_hst_pro ts_hst_pro[PRO_HST]; 
 /* =1 si affichage note possible */
extern defv_bool defv_aff_not_pos;                 
/* = 1 si affichage calcul en cour */
extern defv_bool defv_aff_cal_cou;		
 /* profondeur actuelle	*/        
extern int i_pro_act;                   
/* niveau de simulation */       
extern int i_pro_sim_niv;		
/* nivde simu pour incrément */
extern int i_pro_sim_inc;		
/* profondeur de simulation 		*/
extern int i_pro_sim_act;             	
/* profondeur maximale superieur 	*/
extern int i_pro_sim_max_sup;         	
/* profondeur maximale inferieur	*/
extern int i_pro_sim_max_inf;         	
/* note: compteur mvt initial 		*/	
extern int i_not_cpt_mvt_ini;		
/* ptr sur tableau structure historique  */
extern struct st_hst_pro	*pts_hst_pro; 	
 /* ptr sur tableau structure historique  */
extern struct st_hst_pro	*pts_hst_pro_p;
/* ptr sur tbl structure pièce principale*/
extern struct st_pie  		*pts_pie;      
/* indexe pour retrier les mouvement */
extern struct st_tri_mvt_ini  ts_tri_mvt_ini [MVT_INI];
/* tableau note du mvt initial */
extern ST_NOT_MVT_INI  ts_not_mvt_ini[MVT_INI] ;
extern struct st_eva_sit  st_eva_sit ;
/* Sous Structure  not_mvt_ini pour evaluation mat/pat par profondeur */
extern struct  st_hst_pro_sta tst_pro_sta[MVT_INI][PRO_SIM_INF_MAX]; 

/************************************************************************/ 
/* external function  */
/************************************************************************/

extern char pro_pio_tra_tmvt_lpie (int i_typ_mvt);    /* traduit type mvt en type  piece*/
#ifdef UPLOAD_BRANCHE  
extern int bra_prt_lst(struct st_bra_nod *pst_bra_nod_lst);
#endif


void aff_pie       (int i_cam);
void aff_pie_lin   (int i_pie,struct st_pie *ptst_pie);
void aff_hst_wra   (int i_pro_deb, int i_pro_fin);
void aff_hst       (int i_pro_deb, int i_pro_fin);
int  aff_not_1     (int *pi_mei_mvt);
int  aff_not_2     (int *pi_mei_mvt);
void aff_nex_pag   ();
void aff_pre_pag   ();
int aff_mvt_ini    (int i_mvt_ini);
void aff_cal_en_cou(int i_not_cpt_mvt_ini,int i_aff_typ);
static void for_nul_sci_nbr (char *str);  
static void print_sci_nbr (float f_nbr);
 /* verifie  si affichage note possible */
extern int      ver_aff_not_pos (void);                        
 /* verifie existance mvt ini */
extern int      ver_exi_mvt_ini (int i_mvt_ini);               




/*printing stat */
/* Libelle des type de note */
struct { char *label;}
 lib_typ_not []=
{
  { N_("   Mvt_Nbr") },
  { N_("   Mat_Nbr") },
  { N_(" IcMat_Nbr") },
  { N_("   Sta_Nbr") },
  { N_(" IcSta_Nbr") },
  { N_(" RfMat_Nbr") },
  { N_(" RfSta_Nbr") },
  { N_("  Fork_Nbr") },
  { N_("   Pie_Mob") },
  { N_("   Pie_Cov") },
  { N_("   Pie_Pos") },
};

/* Separateur*/
/* bug find a way to declare it static without a warning messge */

char tc_sep_tir_120[]="\n-----------------------------------------------------------------------------------------------------------------------";
char tc_sep_tir[]="\n-------------------------------------------------------------------------------";

