/*  Chess-Ec      Copyright (C)   2001-2008 Marc Dechico

    ec_simu.i : a common header file where global datas and functions
		are defined. 
		(working to change most of  them to static )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 37 98 22 54
				Mail: ec@chess-ec.org  
    
*/

/* constante tableau mouvemnt */

/* intialisation ptr fonction  suivant position roi */
/* roi haut gauche */
/* static const  void (*tpf_roi_h_g	)(void)[] =*/
static const tpf_xxx tpf_roi_h_g [] =
{
  droite_R ,
  bas_droite_R,
  bas_R,
  pie_sui
};

/* roi haut */
static const tpf_xxx tpf_roi_h	[] =
{
  droite_R,
  bas_droite_R,
  bas_R,
  bas_gauche_R,
  gauche_R,
  pie_sui
};
/* roi pos origine noir */
/* laisser grd et petit roc en fin de tab pour eviter restore de piece */
static const tpf_xxx tpf_roi_pos_ori_1 [] =
{
  droite_R,
  bas_droite_R,
  bas_R,
  bas_gauche_R,
  gauche_R,
  grd_roc_1, /* laisser grd et petit roc en fin de tableau */
  pet_roc_1,
  pie_sui
};
/* roi haut droite */
static const tpf_xxx tpf_roi_h_d[] =
{
  bas_R,
  bas_gauche_R,
  gauche_R,
  pie_sui
};
/* roi droite */
static const tpf_xxx tpf_roi_d[] =
{
  haut_R,
  bas_R,
  bas_gauche_R,
  gauche_R,
  haut_gauche_R,
  pie_sui
};

/* roi bas droite */
static const tpf_xxx tpf_roi_b_d[] =
{
  haut_R,
  gauche_R,
  haut_gauche_R,
  pie_sui
};

/* roi bas */
static const tpf_xxx tpf_roi_b[] =
{
  haut_R,
  haut_droite_R,
  droite_R,
  gauche_R,
  haut_gauche_R,
  pie_sui
};

/* roi pos origine blanc */
/* laisser grd et petit roc en fin de tab pour eviter restore de piece */
static const tpf_xxx tpf_roi_pos_ori_0[] =
{
  haut_R,
  haut_droite_R,
  droite_R,
  gauche_R,
  haut_gauche_R,
  grd_roc_0,	  /* laisser grd et petit roc en fin de tableau */
  pet_roc_0,
  pie_sui
};
/* roi bas gauche */
static const tpf_xxx tpf_roi_b_g[] =
{
  haut_R,
  haut_droite_R,
  droite_R,
  pie_sui
};

/* roi gauche */
static const tpf_xxx tpf_roi_g[] =
{
  haut_R,
  haut_droite_R,
  droite_R,
  bas_droite_R,
  bas_R,
  pie_sui
};

/* roi normal */
static const tpf_xxx tpf_roi_nor[] =
{
  haut_R,
  haut_droite_R,
  droite_R,
  bas_droite_R,
  bas_R,
  bas_gauche_R,
  gauche_R,
  haut_gauche_R,
  pie_sui
};
/* initialisation ptr tbl ptr mvt selon position */

static const tpf_xxx *ptpf_mvt_roi[] =
{
#include "gen/ec_mvt_r.i"
};


/* reine haut gauche */
static const tpf_xxx tpf_rei_h_g[]=
{
  droite,
  bas_droite,
  bas,
  pie_sui
};
/* reine haut */


static const tpf_xxx tpf_rei_h[] =
{
  droite,
  bas_droite,
  bas,
  bas_gauche,
  gauche,
  pie_sui
};
/* reine haut droite */
static const tpf_xxx tpf_rei_h_d[] =
{
  bas,
  bas_gauche,
  gauche,
  pie_sui
};
/* reine droite */
static const tpf_xxx tpf_rei_d[] =
{
  haut,
  bas,
  bas_gauche,
  gauche,
  haut_gauche,
  pie_sui
};
/* reine bas droite */
static const tpf_xxx tpf_rei_b_d[] =
{
  haut,
  gauche,
  haut_gauche,
  pie_sui
};
/* reine bas */
static const tpf_xxx tpf_rei_b[] =
{
  haut,
  haut_droite,
  droite,
  gauche,
  haut_gauche,
  pie_sui
};
/* reine bas gauche */
static const tpf_xxx tpf_rei_b_g[] =
{
  haut,
  haut_droite,
  droite,
  pie_sui
};
/* reine gauche */
static const tpf_xxx tpf_rei_g[] =
{
  haut,
  haut_droite,
  droite,
  bas_droite,
  bas,
  pie_sui
};
/* reine normal */
static const tpf_xxx tpf_rei_nor[] =
{
  haut,
  haut_droite,
  droite,
  bas_droite,
  bas,
  bas_gauche,
  gauche,
  haut_gauche,
  pie_sui
};
/* initialisation ptr tbl ptr mvt selon position */
static const tpf_xxx *ptpf_mvt_rei[] =
{
#include "gen/ec_mvt_d.i"
};

/* fou haut gauche */
static const tpf_xxx tpf_fou_h_g[] =
{

  bas_droite,
  pie_sui
};
/* fou haut */
static const tpf_xxx tpf_fou_h[] =
{
  bas_droite,
  bas_gauche,
  pie_sui
};
/* fou haut droite */
static const tpf_xxx tpf_fou_h_d[] =
{
  bas_gauche,
  pie_sui
};
/* fou droite */
static const tpf_xxx tpf_fou_d[] =
{
  bas_gauche,
  haut_gauche,
  pie_sui
};
/* fou bas droite */
static const tpf_xxx tpf_fou_b_d[] =
{
  haut_gauche,
  pie_sui
};
/* fou bas */
static const tpf_xxx tpf_fou_b[] =
{
  haut_droite,
  haut_gauche,
  pie_sui
};
/* fou bas gauche */
static const tpf_xxx tpf_fou_b_g[] =
{
  haut_droite,
  pie_sui
};
/* fou gauche */
static const tpf_xxx tpf_fou_g[] =
{
  haut_droite,
  bas_droite,
  pie_sui
};
/* fou normal */
static const tpf_xxx tpf_fou_nor[] =
{
  haut_droite,
  bas_droite,
  bas_gauche,
  haut_gauche,
  pie_sui
};
/* initialisation ptr tbl ptr mvt selon position */
static const tpf_xxx *ptpf_mvt_fou[] =
{
#include "gen/ec_mvt_f.i"
};

/* tour haut gauche */
static const tpf_xxx tpf_tou_h_g[] =
{
  droite_tou_gr,
  bas_tou_gr,
  pie_sui
};

/* tour haut */
static const tpf_xxx  tpf_tou_h[]  =
{
  droite,
  bas,
  gauche,
  pie_sui
};
/* tour haut droite */
static const tpf_xxx tpf_tou_h_d[]  = 
{
  bas_tou_pr,
  gauche_tou_pr,
  pie_sui
};

/* tour droite */
static const tpf_xxx  tpf_tou_d[]  = 
{
  haut,
  bas,
  gauche,
  pie_sui
};
/* tour bas droite */
static const tpf_xxx  tpf_tou_b_d[]  =
{
  haut_tou_pr,
  gauche_tou_pr,
  pie_sui
};

/* tour bas */
static const tpf_xxx tpf_tou_b[]  =
{
  haut,
  droite,
  gauche,
  pie_sui
};

/* tour bas gauche */
static const tpf_xxx tpf_tou_b_g[]  = 
{
  haut_tou_gr,
  droite_tou_gr,
  pie_sui
};

/* tour gauche */
static const tpf_xxx tpf_tou_g[]  = 
{
  haut,
  droite,
  bas,
  pie_sui
};

/* tour normal */
static const tpf_xxx tpf_tou_nor[]  =
{
  haut,
  droite,
  bas,
  gauche,
  pie_sui
};
 
/* initialisation ptr tbl ptr mvt selon position */
static const tpf_xxx *ptpf_mvt_tou[] =
{
#include "gen/ec_mvt_t.i"
};


/* intialisation ptr fonction suivant position cavalier */
/* cavalier coin haut gauche */
static const tpf_xxx  tpf_cav_c_h_g[] =
{
  droite_bas_C,
  bas_droite_C,
  pie_sui
};
/* cavalier  haut gauche */
static const tpf_xxx  tpf_cav_h_g[] =
{ 
  droite_bas_C,
  bas_droite_C,
  bas_gauche_C,
  pie_sui
};
/* cavalier haut */
static const tpf_xxx tpf_cav_h[] =
{ 
  droite_bas_C,
  bas_droite_C,
  bas_gauche_C,
  gauche_bas_C,
  pie_sui
};
/* cavalier haut droit */
static const tpf_xxx tpf_cav_h_d[] =
{
  bas_droite_C,
  bas_gauche_C,
  gauche_bas_C,
  pie_sui
};
/* cavalier coin haut droit */
static const tpf_xxx tpf_cav_c_h_d[] =
{
  bas_gauche_C,
  gauche_bas_C,
  pie_sui
};
/* cavalier droite haut */
static const tpf_xxx   tpf_cav_d_h[] =
{
  bas_gauche_C,
  gauche_bas_C,
  gauche_haut_C,
  pie_sui
};
/* cavalier droite */
static const tpf_xxx tpf_cav_d[] =
{
  bas_gauche_C,
  gauche_bas_C,
  gauche_haut_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier droite bas */
static const tpf_xxx tpf_cav_d_b[] =
{
  gauche_bas_C,
  gauche_haut_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier coin bas droite */
static const tpf_xxx tpf_cav_c_b_d[] =
{
  gauche_haut_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier bas droite */
static const tpf_xxx tpf_cav_b_d[] =
{
  haut_droite_C,
  gauche_haut_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier bas */
static const tpf_xxx tpf_cav_b[] =
{
  haut_droite_C,
  droite_haut_C,
  gauche_haut_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier bas gauche */
static const tpf_xxx tpf_cav_b_g[] =
{
  haut_droite_C,
  droite_haut_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier coin bas gauche */
static const tpf_xxx tpf_cav_c_b_g[] =
{
  haut_droite_C,
  droite_haut_C,
  pie_sui
};
/* cavalier gauche bas */
static const tpf_xxx tpf_cav_g_b[] =
{ haut_droite_C,
  droite_haut_C,
  droite_bas_C,
  pie_sui
};
/* cavalier gauche */
static const tpf_xxx tpf_cav_g[] =
{ haut_droite_C,
  droite_haut_C,
  droite_bas_C,
  bas_droite_C,
  pie_sui
};
/* cavalier gauche haut */
static const tpf_xxx tpf_cav_g_h[] =
{ droite_haut_C,
  droite_bas_C,
  bas_droite_C,
  pie_sui
};
/* cavalier interne coin haut gauche */
static const tpf_xxx tpf_cav_i_c_h_g[] =
{ 
  droite_haut_C,
  droite_bas_C,
  bas_droite_C,
  bas_gauche_C,
  pie_sui
};
/* cavalier interne haut */
static const tpf_xxx tpf_cav_i_h[] =
{
  droite_haut_C,
  droite_bas_C,
  bas_droite_C,
  bas_gauche_C,
  gauche_bas_C,
  gauche_haut_C,
  pie_sui
};
/* cavalier interne coin haut droit */
static const tpf_xxx tpf_cav_i_c_h_d[] =
{
  bas_droite_C,
  bas_gauche_C,
  gauche_bas_C,
  gauche_haut_C,
  pie_sui
};
/* cavalier interne droit */
static const tpf_xxx tpf_cav_i_d[] =
{ haut_droite_C,
  bas_droite_C,
  bas_gauche_C,
  gauche_bas_C,
  gauche_haut_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier interne coin bas droite */
static const tpf_xxx tpf_cav_i_c_b_d[] =
{
  haut_droite_C,
  gauche_bas_C,
  gauche_haut_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier interne bas */
static const tpf_xxx tpf_cav_i_b[] =
{
  haut_droite_C,
  droite_haut_C,
  droite_bas_C,
  gauche_bas_C,
  gauche_haut_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier interne coin gauche bas */
static const tpf_xxx tpf_cav_i_c_b_g[] =
{
  haut_droite_C,
  droite_haut_C,
  droite_bas_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier interne gauche */
static const tpf_xxx tpf_cav_i_g[] =
{
  haut_droite_C,
  droite_haut_C,
  droite_bas_C,
  bas_droite_C,
  bas_gauche_C,
  haut_gauche_C,
  pie_sui
};
/* cavalier normal */
static const tpf_xxx tpf_cav_nor[] =
{
  haut_droite_C,
  droite_haut_C,
  droite_bas_C,
  bas_droite_C,
  bas_gauche_C,
  gauche_bas_C,
  gauche_haut_C,
  haut_gauche_C,
  pie_sui
};
/* initialisation ptr tbl ptr mvt selon position */
static const tpf_xxx *ptpf_mvt_cav[] =
{
#include "gen/ec_mvt_c.i"
};


/* intialisation ptr fonction  suivant position pion */
/* laisser haut_2_p_0 sur premier poste  pour eviter restore de piece avant mvt */            
/* pion en ligne 2 gauche */
static const tpf_xxx 	 tpf_pio_0_L2_g[]  =
{
  haut_2_p_0, /* a laisser toujours sur post 0 */
  haut_1_p_0,
  haut_droite_p_0,
  pie_sui
};

/* pion en ligne 2 milieu */
static const tpf_xxx tpf_pio_0_L2[]  =
{
  haut_2_p_0,
  haut_1_p_0,
  haut_gauche_p_0,
  haut_droite_p_0,
  pie_sui
};
/* pion en ligne 2 droite */
static const tpf_xxx tpf_pio_0_L2_d[]  =
{
  haut_2_p_0,
  haut_1_p_0,
  haut_gauche_p_0,
  pie_sui
};
/* pion en ligne 3,4,6 gauche */
static const tpf_xxx tpf_pio_0_L346_g[]  =
{
  haut_1_p_0,
  haut_droite_p_0,
  pie_sui
};
/* pion en ligne 3,4,6 milieu */
static const tpf_xxx tpf_pio_0_L346[]  =
{
  haut_1_p_0,
  haut_gauche_p_0,
  haut_droite_p_0,
  pie_sui
};
/* pion en ligne 3,4,6 droite */
static const tpf_xxx tpf_pio_0_L346_d[]  = 
{
  haut_1_p_0,
  haut_gauche_p_0,
  pie_sui
};
/* pion en ligne 5 gauche */
static const tpf_xxx  tpf_pio_0_L5_g[]  =
{ 
  haut_1_p_0,
  haut_droite_p_0,
  haut_droite_pas_p_0,
  pie_sui
};
/* pion en ligne 5 milieu */
static const tpf_xxx  tpf_pio_0_L5[]  =
{
  haut_1_p_0,
  haut_gauche_p_0,
  haut_droite_p_0,
  haut_gauche_pas_p_0,
  haut_droite_pas_p_0,
  pie_sui
};
/* pion en ligne 5 droite */
static const tpf_xxx  tpf_pio_0_L5_d[]  =
{
  haut_1_p_0,
  haut_gauche_p_0,
  haut_gauche_pas_p_0,
  pie_sui
};
/* conserver l'ordre des postes dans le tableau L7 */
/* car piece remis a position origine apres piece suivante */
/* pion en ligne 7 gauche */
static const tpf_xxx tpf_pio_0_L7_g[]  =
{
  haut_cav_p_0,
  haut_rei_p_0,
  haut_droite_cav_p_0,
  haut_droite_rei_p_0,
  pie_sui
};
/* pion en ligne 7 milieu */
static const tpf_xxx  tpf_pio_0_L7[]  =
{
  haut_cav_p_0,
  haut_rei_p_0,
  haut_droite_cav_p_0,
  haut_gauche_cav_p_0,
  haut_droite_rei_p_0,
  haut_gauche_rei_p_0,
  pie_sui
};
/* pion en ligne 7 droite */
static const tpf_xxx tpf_pio_0_L7_d[]  = 
{
  haut_cav_p_0,
  haut_rei_p_0,
  haut_gauche_cav_p_0,
  haut_gauche_rei_p_0,
  pie_sui
};

/* initialisation ptr tbl ptr mvt selon position */
static const tpf_xxx *ptpf_mvt_pio_0[] =
{
#include "gen/ec_mvtp0.i"
};

/* intialisation ptr fonction  suivant position pion */
/* laisser haut_2_p_0 sur premier poste  pour eviter restore de piece avant mvt */            
/* pion en ligne 7 gauche */
static const tpf_xxx  tpf_pio_1_L7_g[]  =
{
  bas_2_p_1,   /* laisser sur poste  0 */
  bas_1_p_1,
  bas_droite_p_1,
  pie_sui
};

/* pion en ligne 7 milieu */
static const tpf_xxx tpf_pio_1_L7[]  =
{
  bas_2_p_1,
  bas_1_p_1,
  bas_gauche_p_1,
  bas_droite_p_1,
  pie_sui
};

/* pion en ligne 7 droite */
static const tpf_xxx tpf_pio_1_L7_d[]  =
{
  bas_2_p_1,
  bas_1_p_1,
  bas_gauche_p_1,
  pie_sui
};

/* pion en ligne 6,5,3 gauche */
static const tpf_xxx tpf_pio_1_L653_g[]  =
{
  bas_1_p_1,
  bas_droite_p_1,
  pie_sui
};

/* pion en ligne 6,5,3 milieu */
static const tpf_xxx tpf_pio_1_L653[]  =
{
  bas_1_p_1,
  bas_gauche_p_1,
  bas_droite_p_1,
  pie_sui
};

/* pion en ligne 6,5,3 droite */
static const tpf_xxx tpf_pio_1_L653_d[]  =
{
  bas_1_p_1,
  bas_gauche_p_1,
  pie_sui
};

/* pion en ligne 4 gauche */
static const tpf_xxx tpf_pio_1_L4_g[]  =
{
  bas_1_p_1,
  bas_droite_p_1,
  bas_droite_pas_p_1,
  pie_sui
};

/* pion en ligne 4 milieu */
static const tpf_xxx tpf_pio_1_L4[]  =
{
  bas_1_p_1,
  bas_gauche_p_1,
  bas_droite_p_1,
  bas_gauche_pas_p_1,
  bas_droite_pas_p_1,
  pie_sui
};

/* pion en ligne 4 droite */
static const tpf_xxx tpf_pio_1_L4_d[]  =
{
  bas_1_p_1,
  bas_gauche_p_1,
  bas_gauche_pas_p_1,
  pie_sui
};

/* conserver l'ordre des postes dans le tableau L7 */
/* car piece remis a position origine apres piece suivante */
/* pion en ligne 2 gauche */
static const tpf_xxx tpf_pio_1_L2_g[]  =
{ 
  bas_cav_p_1,
  bas_droite_cav_p_1,
  bas_rei_p_1,
  bas_droite_rei_p_1,
  pie_sui
};

/* pion en ligne 2 milieu */
static const tpf_xxx tpf_pio_1_L2[]  =
{
  bas_cav_p_1,
  bas_droite_cav_p_1,
  bas_gauche_cav_p_1,
  bas_rei_p_1,
  bas_droite_rei_p_1,
  bas_gauche_rei_p_1,
  pie_sui
};

/* pion en ligne 2 droite */
static const tpf_xxx tpf_pio_1_L2_d[]  =
{
  bas_cav_p_1,
  bas_gauche_cav_p_1,
  bas_rei_p_1,
  bas_gauche_rei_p_1,
  pie_sui
};
/* initialisation ptr tbl ptr mvt selon position */
static const tpf_xxx *ptpf_mvt_pio_1[] =
{
#include "gen/ec_mvtp1.i"
};


/*  pour detection echec ec_ctl.c */
/*static const int ti_ech_dir_rei[100][100]=*/
 def_ti_ech_dir_rei  ti_ech_dir_rei=
{
#include "gen/ec_echre.i"
}; 
/*static const int ti_ech_dir_tou[100][100]=*/
 def_ti_ech_dir_tou  ti_ech_dir_tou=
{ 
#include "gen/ec_echto.i"
}; 
/*static const int ti_ech_dir_fou[100][100]=*/
 def_ti_ech_dir_fou  ti_ech_dir_fou=
{
#include "gen/ec_echfo.i"
};  
/*static  const int ti_ech_dir_cav[100][100]=*/
 def_ti_ech_dir_cav  ti_ech_dir_cav=
{
#include "gen/ec_echca.i"
}; 
/*static  const int ti_ech_dir_roi[100][100]=*/
 def_ti_ech_dir_roi  ti_ech_dir_roi=
{
#include "gen/ec_echro.i"
}; 
/*static  const int ti_ech_dir_pio_noi[100][100]=*/
 def_ti_ech_dir_pio_noi  ti_ech_dir_pio_noi=
{
#include "gen/ec_echpn.i"
}; 
/*static  const int ti_ech_dir_pio_bla[100][100]=*/
 def_ti_ech_dir_pio_bla  ti_ech_dir_pio_bla=
{
#include "gen/ec_echpb.i"
}; 
/*static  const int ti_ech_dir_inc[100][100]=*/
 def_ti_ech_dir_inc  ti_ech_dir_inc=
{
#include "gen/ec_echin.i"
}; 


/* chargement du tableau (statique) controle à nouveau echec demasquage*/
/* const provoque warning initialisation from incompatible pointer type */
/*int (*tpf_cas_ctl[19])     (int n,int i_cam_adv)=*/
def_tpf_cas_ctl  tpf_cas_ctl=
{
  /* 0 */ cas_ctl_nul,    /* appelle pour controle echec demasquage  prise en passant 
			     de la fct jou_mvt_pio: Ne peu tester si la direction est 
			     = 0 (elle est recalculee dans test if) et donc l'index 0
			     du tableau de pointeur peut etre appele  */	
  /*  1 */ cas_ctl_h_d,
  /*  2 */ cas_ctl_h_g,
  /*  3 */ cas_ctl_b_d,
  /*  4 */ cas_ctl_b_g,

  /*  5 */ cas_ctl_h,
  /*  6 */ cas_ctl_b,
  /*  7 */ cas_ctl_d,
  /*  8 */ cas_ctl_g,

  /*  9 */ cas_ctl_cav_h_d,
  /* 10 */ cas_ctl_cav_d_h,
  /* 11 */ cas_ctl_cav_d_b,
  /* 12 */ cas_ctl_cav_b_d,
  /* 13 */ cas_ctl_cav_b_g,
  /* 14 */ cas_ctl_cav_g_b,
  /* 15 */ cas_ctl_cav_g_h,
  /* 16 */ cas_ctl_cav_h_g,

  /* 17 */ cas_ctl_pio_d,
  /* 18 */ cas_ctl_pio_g

};


