/*
    
    Chess-Ec     Copyright (C)   2001-2008 Marc Dechico

    ec_test.h :  automat to find bugs in the engine (play random)
		  automat to compare methode of evaluation 
		  function used for debugging

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 37 98 22 54
				Mail: ec@chess-ec.org  
    
*/
#include "ec_global.h"

#ifdef TEST

/************************************************************************/ 
/* external datas */
/************************************************************************/ 
extern int i_not_cpt_mvt_ini;			/* note: compteur mvt initial 		*/
extern defv_bool defv_aff_cal_cou;		/* = 1 si affichage calcul en cour */
extern struct st_hst_pro	*pts_hst_pro; 	/* ptr sur tableau structure historique  */
extern int i_pro_act;                           /* profondeur actuelle	*/
extern int i_pro_sim_niv;			/* niveau de simulation */
extern int i_pro_sim_inc;			/* nivde simu pour incrémen*/
extern ST_NOT_MVT_INI  ts_not_mvt_ini[MVT_INI]; /* tableau note du mvt initial */
extern  struct st_hst_pro ts_hst_pro[PRO_HST];  /* tableau historique des coups */
extern int (*pf_eva) (void);  	                /* pointeur sur fonction évaluation */



/************************************************************************/ 
/* external function */
/************************************************************************/ 
/* affichage de l'échiquier */
extern void aff_ech (int i_cam);

extern void 	ini_pgm      (void);                /* ec_ini */
extern int  simul(int i_pro_sim_niv_wrk,	    /* retourne meilleur mouvement */
		  int i_pro_sim_inc_wrk,
		  defv_bool defv_bool__hash,
		  defv_bool defv_bool_ini_mvt_ini,
		  defv_bool defv_bool_ini_rap_for,
		  def_pf_not_cal pf_not_cal,
		  int i_cam_adv );
extern int sim_jou(void);                       /* simul et joue  */
extern int  sav_dsk (char tc_nom_fic[40]);
extern  int jou	   (int i_pos_dep_n,  		/* joue avec coordonnes reelles */	 
		    int i_pos_arr_n,
		    char c_rem_pio	);
extern char pro_pio_tra_tmvt_tpie (int i_typ_mvt);     /* traduit type mvt en type  piece*/

extern void 	not_cal (void);                 /* calcule et mémorisation de la note du mvt initial */


extern void tra_don (enum e_sit_typ_not_pos);  /* traitement des données */
extern void cho_coe_02 	(void);		       /* Choix coeficient */
extern void pon_not (void);		       /* Pondération note */
extern void tri_mvt_rec (void);		       /* tri des mvt initial par ordre decroissant not_rec*/
/************************************************************************/ 
/* local function */
/************************************************************************/ 

 void  	sim_aut 	(void);			/* pour faire jouer automatiquement */
 void  	test_aut 	(void);			/* pour rechercher d'éventuel bugs  */
void test01(void);
static int 	jou_par_aut	(int i_mvt_ini);/* joue une partie automatiquement */ 
static int eva_mei_mvt_test(void);		/* retourne mouvement aux hasard */

/************************************************************************/ 
/* local datas */
/************************************************************************/ 

/* make the engine work alone in order to meet a bug like king taken! */ 
struct des_par {
  int ver[2];   		/* Numero de la version  */
  int (*pf_eva[2])(void); 	/* Pointeur sue la fct d'évaluation */
  int pro[2];			/* profondeur de simu  utilisée*/
  int inc[2];			/* incrément de la simu */
  int mvt_ini;			/* mvr initial */
  int ver_bla;			/* Versin utilisé pour les blancs */
  int ver_noi;			/* Versin utilisé pour les blancs */
  char	 cam_gag;			/* Camp gagnant */
} des_par;
int (*pf_eva_cam[2]) (void) ;	/* Fct dévaluation par cam */
#endif
